Attribute VB_Name = "Programs"
Option Explicit
Global Const gcReleaseVersion = True
Global gsApplicationName As String
Global gsPathAndDatabaseName As String
Global Const gcPlaceHolder = "<???>"
Global Const gcNoFilter = -10000
Global Const gcQuestionMarks = -5000
Global Const gcnNumberOfJobRemarkFields = 6

Global gdbMain As Database
Global grsSendlog As Recordset

Global gSMS As Booster

Type DeferredDeliveryTimeSettings
  bUseDeferredDeliveryTime As Boolean
  nTimeZone As Integer
  bSingleSMS As Boolean
  bPeriodicSMS As Boolean
  sDeliveryDate As String
  sStartingDate As String
  sNumberOfMessages As String
  sWaitingTime As String
  nWaitingPeriod As Integer
End Type

Type FontSettings
  bSpecificFontUsed As Boolean
  sFontName As String
  rFontSize As Double
  bFontBold As Boolean
  bFontItalic As Boolean
End Type

Type JobLogFilterSettings
  bJobRemarksFilterUsed(1 To gcnNumberOfJobRemarkFields) As Boolean
  sJobRemarks(1 To gcnNumberOfJobRemarkFields) As String
  bSMSTypeFilterUsed As Boolean
  sSMSType As String
  bSendingTypeFilterUsed As Boolean
  sSendingType As String
End Type

Type SendLogFilterSettings
  bRecipientNameFilterUsed As Boolean
  sRecipientName As String
  bRecipientFilterUsed As Boolean
  sRecipient As String
  bDeliveryStatusFilterUsed As Boolean
  nDeliveryStatus As Integer
  bReasonCodeFilterUsed As Boolean
  nReasonCode As Integer
  bJobIDFilterUsed As Boolean
  lJobId As Long
End Type

Type PhoneBookEntry
  sName As String
  sNumber As String
  sVariable1 As String
  sVariable2 As String
  sVariable3 As String
End Type

Type JobInfo
  lRecipients As Long
  lMessages As Long
  sSMSType As String
  tDeferredDeliveryTimeSettings As DeferredDeliveryTimeSettings
End Type

Type DBLogFieldsSettings
  bSendLog(1 To 16) As Boolean
  bJobLog(1 To 16) As Boolean
End Type

Enum ValidityPeriodMode
  UseSpecificSettingsAsLifeTime = 1
  UseSingleshotAsLifeTime = 2
  UseWaitingTimeAsLifeTime = 3
End Enum

Type ValidityPeriod
  bStandardPeriod As Boolean
  bUserDefinedSettingsOnlyForSpecificSMSTypes As Boolean
  lLifeTime As Long
  nLifeTimeUnit As Integer
End Type

Type ValidityPeriodSettings
  bSingleSMSUseUserDefinedLifeTime As Boolean
  bSingleSMSUseUserDefinedSettingsOnlyForSpecificSMSTypes As Boolean
  nSingleSMSValidityPeriodMode As ValidityPeriodMode
  lSingleSMSSpecificSettingLifeTime As Long
  nSingleSMSSpecificSettingLifeTimeUnit As Integer

  bPeriodicSMSUseUserDefinedLifeTime As Boolean
  bPeriodicSMSUseUserDefinedSettingsOnlyForSpecificSMSTypes As Boolean
  nPeriodicSMSValidityPeriodMode As ValidityPeriodMode
  lPeriodicSMSSpecificSettingLifeTime As Long
  nPeriodicSMSSpecificSettingLifeTimeUnit As Integer
End Type

Global gtValidityPeriodSettings As ValidityPeriodSettings

Global gsPhonebookVariableField(1 To 2, 1 To 3) As String

Global gtDBLogFieldsSettings As DBLogFieldsSettings

Global gtJobInfo As JobInfo

Global gtFontSettingsCurrent As FontSettings
Global gtFontSettingsDefault As FontSettings
Global gtMenuControl As MenuControl

Global gtJobLogFilterSettings As JobLogFilterSettings
Global gtSendLogFilterSettings As SendLogFilterSettings
Global gbSaveMessagesInSendLog As Boolean
Global glJobIDEditJobRemarks As Long

Global gtDeferredDeliveryTimeSettings As DeferredDeliveryTimeSettings
Global gnLanguage As Integer

Global gnSelectedRandomLogo As Integer
Global gsSQLSendjournal As String

Global gnPhoneBookSortOrder As Integer


Declare Function ShellExecute Lib "shell32.dll" Alias _
    "ShellExecuteA" (ByVal hWnd As Long, ByVal lpOperation As String, _
           ByVal lpFile As String, ByVal lpParameters As String, _
           ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long

Global Const gcErrorCodeOk = 1
Global Const gcErrorCodeConnectFailed = 2
Global Const gcErrorCodeAuthorizationFailed = 3
Global Const gcErrorCodeBinaryFileNotFound = 4
Global Const gcErrorCodeNotEnoughCreditsAvailable = 5
Global Const gcErrorCodeTimeOutError = 6
Global Const gcErrorCodeTransmissionErrorTryAgain = 7
Global Const gcErrorCodeInvalidUserKey = 8
Global Const gcErrorCodeInvalidPassword = 9
Global Const gcErrorCodeInvalidOriginator = 10
Global Const gcErrorCodeInvalidMessageData = 11
Global Const gcErrorCodeInvalidBinaryData = 12
Global Const gcErrorCodeInvalidBinaryFile = 13
Global Const gcErrorCodeInvalidMCC = 14
Global Const gcErrorCodeInvalidMNC = 15
Global Const gcErrorCodeInvalidxSer = 16
Global Const gcErrorCodeInvalidURLBufferedMessageNotification = 17
Global Const gcErrorCodeInvalidURLDeliveryNotification = 18
Global Const gcErrorCodeInvalidURLNonDeliveryNotification = 19
Global Const gcErrorCodeMissingRecipient = 20
Global Const gcErrorCodeMissingBinaryData = 21
Global Const gcErrorCodeInvalidDeferredDeliveryTime = 22
Global Const gcErrorCodeMissingTransactionReferenceNumber = 23
Global Const gcErrorCodeServiceTemporaryNotAvailable = 24
Global Const gcErrorCodeUserBarringActive = 25
Global Const gcErrorCodeNotAuthorizedForThisOperation = 26
Global Const gcErrorCodeMessageTooLong = 27
Global Const gcErrorCodeNoOriginatorRestrictions = 28
Global Const gcErrorCodeOriginatorAuthorizationPending = 29
Global Const gcErrorCodeOriginatorNotAuthorized = 30
Global Const gcErrorCodeOriginatorAlreadyAuthorized = 31


Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long) As Long
Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

Private Const WM_MOUSEWHEEL = &H20A ' window message for mouse wheel
Public Const GWL_WNDPROC = (-4)
Global gOldwndProcfrmSMSBlaster As Long
Global gOldwndProcfrmJobLog As Long
Global gOldwndProcfrmSendLog As Long
Global gOldwndProcfrmImport As Long


Public Sub FlexGridScrollDown(grdFlexGrid As MSFlexGrid)
Dim lTopRow As Long
Dim lNewTopRow As Long
Dim lRows As Long
Dim lRowHeight As Long

Select Case True
  Case grdFlexGrid.Rows > 2
  lRowHeight = grdFlexGrid.RowPos(2) - grdFlexGrid.RowPos(1)
  
  Case grdFlexGrid.Rows > 1
  lRowHeight = grdFlexGrid.RowPos(1) - grdFlexGrid.RowPos(0)
  
End Select

If (grdFlexGrid.Rows + 1) * lRowHeight <= grdFlexGrid.Height Then
  Exit Sub
Else
  'Do nothing
End If

lTopRow = grdFlexGrid.TopRow
lRows = grdFlexGrid.Rows

If lTopRow < lRows - 1 Then
  Select Case True
    Case lRows > 5000
    lNewTopRow = lTopRow + 10
    
    Case lRows > 1000
    lNewTopRow = lTopRow + 5
    
    Case lRows > 500
    lNewTopRow = lTopRow + 4
    
    Case lRows > 100
    lNewTopRow = lTopRow + 3
    
    Case lRows > 50
    lNewTopRow = lTopRow + 2
    
    Case Else
    lNewTopRow = lTopRow + 1
    
  End Select
  
  If lNewTopRow >= lRows Then
    lNewTopRow = lRows - 1
  End If
  
  grdFlexGrid.TopRow = lNewTopRow
End If

End Sub

Public Sub FlexGridScrollUp(grdFlexGrid As MSFlexGrid)
' scroll up..
Dim lTopRow As Long
Dim lNewTopRow As Long
Dim lRows As Long

lTopRow = grdFlexGrid.TopRow
lRows = grdFlexGrid.Rows

If lTopRow > 1 Then
  Select Case True
    Case lRows > 5000
    lNewTopRow = lTopRow - 10
    
    Case lRows > 1000
    lNewTopRow = lTopRow - 5
    
    Case lRows > 500
    lNewTopRow = lTopRow - 4
    
    Case lRows > 100
    lNewTopRow = lTopRow - 3
    
    Case lRows > 50
    lNewTopRow = lTopRow - 2
    
    Case Else
    lNewTopRow = lTopRow - 1
    
  End Select
  
  If lNewTopRow < 1 Then
    lNewTopRow = 1
  End If
  
  grdFlexGrid.TopRow = lNewTopRow
End If



End Sub

Public Function MouseWheelSupportWndProcfrmSMSBlaster(ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Dim bMouseWheelUp As Boolean
Dim lNewScrollValue As Long

If wMsg = WM_MOUSEWHEEL Then
  If wParam > 0 Then bMouseWheelUp = True Else bMouseWheelUp = False
  
  Select Case frmSMSBlaster.TabMain.Tab
  
    Case 1    'Phonebook Tab
    Select Case frmSMSBlaster.ActiveControl
      Case frmSMSBlaster.grdRecipients
        If bMouseWheelUp Then
          FlexGridScrollUp frmSMSBlaster.grdRecipients
        Else
          FlexGridScrollDown frmSMSBlaster.grdRecipients
        End If
          
      Case Else
        If bMouseWheelUp Then
          FlexGridScrollUp frmSMSBlaster.grdPhonebook
        Else
          FlexGridScrollDown frmSMSBlaster.grdPhonebook
        End If
    End Select

    Case 10   'WAP Push Tab
    If frmSMSBlaster.scrlVertical.Visible = True Then
      lNewScrollValue = frmSMSBlaster.scrlVertical.Value
    
      Select Case bMouseWheelUp
      Case True
      lNewScrollValue = lNewScrollValue - frmSMSBlaster.scrlVertical.SmallChange
      
      Case False
      lNewScrollValue = lNewScrollValue + frmSMSBlaster.scrlVertical.SmallChange
                
      End Select
      If lNewScrollValue > frmSMSBlaster.scrlVertical.Max Then
        lNewScrollValue = frmSMSBlaster.scrlVertical.Max
      End If
  
      If lNewScrollValue < frmSMSBlaster.scrlVertical.Min Then
        lNewScrollValue = frmSMSBlaster.scrlVertical.Min
      End If
      frmSMSBlaster.scrlVertical.Value = lNewScrollValue
    End If
  
  Case Else
  'Do nothing
  
  End Select
End If
    
MouseWheelSupportWndProcfrmSMSBlaster = CallWindowProc(gOldwndProcfrmSMSBlaster, hWnd, wMsg, wParam, lParam)
End Function

Public Function MouseWheelSupportWndProcfrmSendlog(ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Dim bMouseWheelUp As Boolean

If wMsg = WM_MOUSEWHEEL Then
    
  If wParam > 0 Then bMouseWheelUp = True Else bMouseWheelUp = False
    
  Select Case bMouseWheelUp
    Case True
    FlexGridScrollUp frmSendLog.grdSendLog
   
    Case False
    FlexGridScrollDown frmSendLog.grdSendLog
   
  End Select
End If
    
MouseWheelSupportWndProcfrmSendlog = CallWindowProc(gOldwndProcfrmSendLog, hWnd, wMsg, wParam, lParam)
End Function


Public Function MouseWheelSupportWndProcfrmJoblog(ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Dim bMouseWheelUp As Boolean

If wMsg = WM_MOUSEWHEEL Then
    
  If wParam > 0 Then bMouseWheelUp = True Else bMouseWheelUp = False
    
  Select Case bMouseWheelUp
    Case True
    FlexGridScrollUp frmJoblog.grdJobLog
    
    Case False
    FlexGridScrollDown frmJoblog.grdJobLog
    
  End Select
  
End If
    
MouseWheelSupportWndProcfrmJoblog = CallWindowProc(gOldwndProcfrmJobLog, hWnd, wMsg, wParam, lParam)
End Function



Public Function MouseWheelSupportWndProcfrmImport(ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Dim bMouseWheelUp As Boolean

If wMsg = WM_MOUSEWHEEL Then
    
  If wParam > 0 Then bMouseWheelUp = True Else bMouseWheelUp = False
    
  Select Case bMouseWheelUp
    Case True
    FlexGridScrollUp frmImport.grdImport
    
    Case False
    FlexGridScrollDown frmImport.grdImport
    
  End Select
  
End If
    
MouseWheelSupportWndProcfrmImport = CallWindowProc(gOldwndProcfrmImport, hWnd, wMsg, wParam, lParam)
End Function




Sub CheckForRequiredDirectories(sPath As String)
Dim sTempPath As String
Dim sTempArray() As String
Dim i As Integer

sTempArray = Split(sPath, "\")

For i = LBound(sTempArray) To UBound(sTempArray)
  sTempPath = sTempPath & sTempArray(i) & "\"
  If DirectoryExists(sTempPath) Then
    'Everything ok, do nothing
  Else
    MkDir sTempPath
  End If
Next
End Sub


Function CreateWAPPushDestinationFileName(sFilename As String) As String
Dim sTempArray() As String
Dim sFileNamePrefix As String
Dim sFileServerName As String
Dim sFileServerPath As String

'Determine Filename according date
sFileNamePrefix = Trim(DatePart("yyyy", Now()))
sFileNamePrefix = sFileNamePrefix & Right("00" & Trim(DatePart("m", Now())), 2)
sFileNamePrefix = sFileNamePrefix & Right("00" & Trim(DatePart("d", Now())), 2)
sFileNamePrefix = sFileNamePrefix & Right("00" & Trim(DatePart("h", Now())), 2)
sFileNamePrefix = sFileNamePrefix & Right("00" & Trim(DatePart("n", Now())), 2)
sFileNamePrefix = sFileNamePrefix & Right("00" & Trim(DatePart("s", Now())), 2)

CreateWAPPushDestinationFileName = sFileNamePrefix & Trim(sFilename)
End Function


Function DirectoryExists(sPath As String) As Boolean
Dim sDirResult As String

sDirResult = Dir$(sPath, vbDirectory)

If sDirResult <> "" Then
  DirectoryExists = True
Else
  DirectoryExists = False
End If

End Function

Function ExtractFilenameWithExtension(sFilename As String) As String
Dim sTempArray() As String
Dim sTemp As String

On Error GoTo ErrorTrap

sTempArray() = Split(sFilename, "\")

sTemp = sTempArray(UBound(sTempArray))

ExtractFilenameWithExtension = sTempArray(UBound(sTempArray))

ErrorTrap:
Exit Function


End Function

Function ExtractFilenameWithoutExtension(sFilename As String) As String
Dim sTempArray() As String
Dim sTemp As String

On Error GoTo ErrorTrap

sTempArray() = Split(sFilename, "\")

sTemp = sTempArray(UBound(sTempArray))
sTempArray = Split(sTemp, ".")

ExtractFilenameWithoutExtension = sTempArray(LBound(sTempArray))

ErrorTrap:
Exit Function

End Function

Function FilesDropped(ByRef Data As TabDlg.DataObject) As String
Dim V As TabDlg.DataObjectFiles, i As Long, s As String, f As String
On Error GoTo Err_Init
Dim sTemp As String
Dim sTemp2 As String
Dim nFile As Integer

Set V = Data.Files
  If Not (V Is Nothing) Then
    For i = 1 To V.Count
      f = V.Item(i)
      'Resolve it first if it's a shortcut
      If Len(f) > 3 Then
        If StrComp(Right$(f, 4), ".lnk", vbTextCompare) = 0 Then
          'f = ResolveLink(f)
          End If
        End If
      If Dir(f, vbNormal Or vbArchive) = "" Then
        If Dir(f, vbDirectory) = "" Then
          'Can't add it to the list
        Else
          'If it's a directory, add a "\" on the end of it.
          If Right$(f, 1) <> "\" Then
            f = f & "\"
          End If
          'Add the directory to the list
          s = s & f & vbCrLf
        End If
      Else
        'Add the file to the list
        s = s & f & vbCrLf
      End If
    Next i
 End If
FilesDropped = s
Exit Function
Err_Init:
If Err.Number = 461 Then
  MsgBox LoadLanguageSpecificString(gnLanguage, 741), vbExclamation, gsApplicationName
  f = ""
  Resume Next
Else
  MsgBox LoadLanguageSpecificString(gnLanguage, 741), vbExclamation, gsApplicationName
End If

End Function



Function CheckOriginatorBeforeSending() As Boolean
Dim sMessage As String
Dim nAnswer As Integer
Screen.MousePointer = vbHourglass

Dim SMS As Booster
Set SMS = Nothing

Set SMS = New Booster
SMS.Hosts = App.Path & "\smshosts.txt"
SMS.UserKey = frmSMSBlaster.txtUserkey.Text
SMS.Password = frmSMSBlaster.txtPassword.Text

SMS.Originator = frmSMSBlaster.txtOriginator
SMS.CheckOriginatorAuthorization
  
Screen.MousePointer = vbDefault

Select Case SMS.ErrorCode
  Case gcErrorCodeOk
  CheckOriginatorBeforeSending = True
  
  Case gcErrorCodeNoOriginatorRestrictions
  CheckOriginatorBeforeSending = True
  
  Case gcErrorCodeOriginatorAlreadyAuthorized
  CheckOriginatorBeforeSending = True
  
  Case gcErrorCodeOriginatorNotAuthorized, gcErrorCodeOriginatorAuthorizationPending
  sMessage = LoadLanguageSpecificString(gnLanguage, 813) & " '" & frmSMSBlaster.txtOriginator & "' " & LoadLanguageSpecificString(gnLanguage, 814) & vbCrLf & _
             LoadLanguageSpecificString(gnLanguage, 815)
  nAnswer = MsgBox(sMessage, vbExclamation Or vbOKCancel Or vbDefaultButton2, gsApplicationName)
  If nAnswer = vbCancel Then
    CheckOriginatorBeforeSending = False
  Else
    CheckOriginatorBeforeSending = True
  End If

  Case Else
  MsgBox LoadLanguageSpecificString(gnLanguage, 207) & vbCrLf & ErrorDescriptionFromASPSMSErrorCode(gnLanguage, CInt(SMS.ErrorCode)), vbExclamation, gsApplicationName
  CheckOriginatorBeforeSending = False
  
End Select

Set SMS = Nothing

End Function

Sub ShowServerFeedback(nStep As Integer, sOriginator As String, nErrorCode As Integer)
Dim sTemp As String

Select Case nErrorCode
  Case gcErrorCodeOk
  Select Case nStep
    Case 1
    sTemp = LoadLanguageSpecificString(gnLanguage, 783) & " '" & sOriginator & "' " & LoadLanguageSpecificString(gnLanguage, 784)
    Case 2
    sTemp = LoadLanguageSpecificString(gnLanguage, 803) & " '" & sOriginator & "' " & LoadLanguageSpecificString(gnLanguage, 804)
    Case 3
    sTemp = LoadLanguageSpecificString(gnLanguage, 801)
  End Select
  MsgBox sTemp, vbInformation, gsApplicationName
  
  Case gcErrorCodeNoOriginatorRestrictions
  Select Case nStep
    Case 1
    sTemp = LoadLanguageSpecificString(gnLanguage, 794) & " " & LoadLanguageSpecificString(gnLanguage, 795)
    Case 2
    sTemp = LoadLanguageSpecificString(gnLanguage, 794) & " " & LoadLanguageSpecificString(gnLanguage, 795)
    Case 3
    sTemp = LoadLanguageSpecificString(gnLanguage, 794) & " " & LoadLanguageSpecificString(gnLanguage, 795)
  End Select
  MsgBox sTemp, vbInformation, gsApplicationName
    
  Case gcErrorCodeOriginatorAuthorizationPending
  Select Case nStep
    Case 1
    sTemp = LoadLanguageSpecificString(gnLanguage, 790) & " '" & sOriginator & "' " & LoadLanguageSpecificString(gnLanguage, 791)
    Case 2
    'Impossible
    Case 3
    'Impossible
  End Select
  MsgBox sTemp, vbInformation, gsApplicationName
  
  Case gcErrorCodeOriginatorNotAuthorized
  Select Case nStep
    Case 1
    sTemp = LoadLanguageSpecificString(gnLanguage, 786) & " '" & sOriginator & "' " & LoadLanguageSpecificString(gnLanguage, 787)
    Case 2
    '????????????
    Case 3
    sTemp = LoadLanguageSpecificString(gnLanguage, 802)
  End Select
  MsgBox sTemp, vbExclamation, gsApplicationName
  
  Case gcErrorCodeOriginatorAlreadyAuthorized
  Select Case nStep
    Case 1
    sTemp = LoadLanguageSpecificString(gnLanguage, 806)
    Case 2
    sTemp = LoadLanguageSpecificString(gnLanguage, 806)
    Case 3
    sTemp = LoadLanguageSpecificString(gnLanguage, 806)
  End Select
  MsgBox sTemp, vbInformation, gsApplicationName
  
  Case Else
  MsgBox LoadLanguageSpecificString(gnLanguage, 207) & vbCrLf & ErrorDescriptionFromASPSMSErrorCode(gnLanguage, nErrorCode), vbExclamation, gsApplicationName

End Select

End Sub



Function ActualValidityPeriod() As ValidityPeriod
Dim lValidityPeriod As Long
Dim bPeriodicJob As Boolean
Dim sDecisionRule As String

bPeriodicJob = PeriodicJob()
'Decisiontable
'                                         R1  R2  R3  R4  R5  R6  R7  R8
'
'B1  bSingleSMSUseUserDefinedLifeTime     N   N   N   N   Y   Y   Y   Y
'B2  bPeriodicSMSUseUserDefinedLifeTime   N   N   Y   Y   N   N   Y   Y
'B3  bPeriodicJob                         N   Y   N   Y   N   Y   N   Y
'
'A1  Standard Lifetime                    Y   Y   Y   -   -   Y   -   -
'A2  Userdefined Lifetime (Single)        -   -   -   -   Y   -   Y   -
'A3  Userdefined Lifetime (Periodic)      -   -   -   Y   -   -   -   Y

If gtValidityPeriodSettings.bSingleSMSUseUserDefinedLifeTime = True Then
  sDecisionRule = sDecisionRule & "Y"
Else
  sDecisionRule = sDecisionRule & "N"
End If

If gtValidityPeriodSettings.bPeriodicSMSUseUserDefinedLifeTime = True Then
  sDecisionRule = sDecisionRule & "Y"
Else
  sDecisionRule = sDecisionRule & "N"
End If

If bPeriodicJob = True Then
  sDecisionRule = sDecisionRule & "Y"
Else
  sDecisionRule = sDecisionRule & "N"
End If

Select Case sDecisionRule
  Case "NNN"  'Standard Lifetime
  ActualValidityPeriod.bStandardPeriod = True
      
  Case "NNY"  'Standard Lifetime
  ActualValidityPeriod.bStandardPeriod = True
      
  Case "NYN"  'Standard Lifetime
  ActualValidityPeriod.bStandardPeriod = True
      
  Case "NYY"  'Userdefined Lifetime (Periodic)
  ActualValidityPeriod = ValidityPeriodWithSpecificSettings(gtValidityPeriodSettings, gtDeferredDeliveryTimeSettings, True)
    
  Case "YNN"  'Userdefined Lifetime (Single)
  ActualValidityPeriod = ValidityPeriodWithSpecificSettings(gtValidityPeriodSettings, gtDeferredDeliveryTimeSettings, False)
  
  Case "YNY"  'Standard Lifetime
  ActualValidityPeriod.bStandardPeriod = True
      
  Case "YYN"  'Userdefined Lifetime (Single)
  ActualValidityPeriod = ValidityPeriodWithSpecificSettings(gtValidityPeriodSettings, gtDeferredDeliveryTimeSettings, False)
  
  Case "YYY"  'Userdefined Lifetime (Periodic)
  ActualValidityPeriod = ValidityPeriodWithSpecificSettings(gtValidityPeriodSettings, gtDeferredDeliveryTimeSettings, True)
  
  Case Else
  'MsgBox "Case Else DecisionTable"
  
End Select
End Function
Sub CopySelectedGridAreaToClipboard(grdInput As MSFlexGrid)
Dim sContent As String
Dim sCell As String
Dim lCurrentRow As Long
Dim lCurrentCol As Long
Dim lStartRow As Long
Dim lEndRow As Long
Dim lStartCol As Long
Dim lEndCol As Long

If grdInput.RowSel = 0 Or grdInput.Row = 0 Then
  Exit Sub
End If

On Error GoTo ErrorTrap

Screen.MousePointer = vbHourglass
If grdInput.RowSel < grdInput.Row Then
  lStartRow = grdInput.RowSel
  lEndRow = grdInput.Row
Else
  lStartRow = grdInput.Row
  lEndRow = grdInput.RowSel
End If

If grdInput.ColSel < grdInput.Col Then
  lStartCol = grdInput.ColSel
  lEndCol = grdInput.Col
Else
  lStartCol = grdInput.Col
  lEndCol = grdInput.ColSel
End If


For lCurrentCol = lStartCol To lEndCol
  sCell = grdInput.TextMatrix(0, lCurrentCol)
  sContent = sContent & sCell & vbTab
Next
sContent = Left(sContent, Len(sContent) - 1) & vbCrLf

For lCurrentRow = lStartRow To lEndRow
  For lCurrentCol = lStartCol To lEndCol
  sCell = grdInput.TextMatrix(lCurrentRow, lCurrentCol)
    sContent = sContent & sCell & vbTab
  Next
  sContent = Left(sContent, Len(sContent) - 1) & vbCrLf
Next

Clipboard.Clear
Clipboard.SetText sContent

Screen.MousePointer = vbDefault

ErrorTrap:
Exit Sub
Screen.MousePointer = vbDefault
End Sub

Sub CurrentPositionWithinGrid(grdInput As MSFlexGrid, rx As Single, ry As Single, lCol As Long, lRow As Long)
Dim lTopRow As Long
Dim lCurrentRow As Long
Dim lCurrentCol As Long
Dim lRowHeight As Long
Dim lColWidth As Long

On Error GoTo ErrorTrap

Select Case True
  Case grdInput.Rows > 2
  lRowHeight = grdInput.RowPos(2) - grdInput.RowPos(1)
  
  Case grdInput.Rows > 1
  lRowHeight = grdInput.RowPos(1) - grdInput.RowPos(0)
  
End Select

If lRowHeight > 0 Then
  lCurrentRow = (Abs(grdInput.RowPos(1)) + ry - (lRowHeight / 2)) / lRowHeight
  'Because of first Row, which is fixed
  If grdInput.RowPos(1) < 0 Then
    lCurrentRow = lCurrentRow + 1
  Else
    lCurrentRow = lCurrentRow - 1
  End If
  If ry <= lRowHeight Then
    lCurrentRow = 0
  End If
Else
  
End If

Do
  If lCurrentCol < grdInput.Cols Then
    If grdInput.ColPos(lCurrentCol) < rx Then
      lCurrentCol = lCurrentCol + 1
    Else
      Exit Do
    End If
  Else
    Exit Do
  End If
Loop
lCurrentCol = lCurrentCol - 1


If lCurrentRow <= grdInput.Rows - 1 And lCurrentCol <= grdInput.Cols - 1 And lCurrentRow > -1 And lCurrentCol > -1 Then
  grdInput.ToolTipText = grdInput.TextMatrix(lCurrentRow, lCurrentCol)
Else

End If

lCol = lCurrentCol
lRow = lCurrentRow

Exit Sub
ErrorTrap:
lCol = 0
lRow = 0
Exit Sub
End Sub

Function FileExists(sFile As String) As Integer
On Error Resume Next

FileExists = (Dir$(sFile) <> "")

End Function

Function CreatePersonalizedMessageData(sInput As String, lRecipient As Long, bVariableMessageData As Boolean) As String
Dim sMessage As String
Dim bReplacementProcessed As Boolean

sMessage = sInput
sMessage = Replace(sMessage, LoadLanguageSpecificString(1, 234), frmSMSBlaster.grdRecipients.TextMatrix(lRecipient, 0))
sMessage = Replace(sMessage, LoadLanguageSpecificString(2, 234), frmSMSBlaster.grdRecipients.TextMatrix(lRecipient, 0))
sMessage = Replace(sMessage, LoadLanguageSpecificString(1, 235), frmSMSBlaster.grdRecipients.TextMatrix(lRecipient, 1))
sMessage = Replace(sMessage, LoadLanguageSpecificString(2, 235), frmSMSBlaster.grdRecipients.TextMatrix(lRecipient, 1))
  
sMessage = Replace(sMessage, "<" & gsPhonebookVariableField(1, 1) & ">", frmSMSBlaster.grdRecipients.TextMatrix(lRecipient, 2))
sMessage = Replace(sMessage, "<" & gsPhonebookVariableField(2, 1) & ">", frmSMSBlaster.grdRecipients.TextMatrix(lRecipient, 2))
  
sMessage = Replace(sMessage, "<" & gsPhonebookVariableField(1, 2) & ">", frmSMSBlaster.grdRecipients.TextMatrix(lRecipient, 3))
sMessage = Replace(sMessage, "<" & gsPhonebookVariableField(2, 2) & ">", frmSMSBlaster.grdRecipients.TextMatrix(lRecipient, 3))
  
sMessage = Replace(sMessage, "<" & gsPhonebookVariableField(1, 3) & ">", frmSMSBlaster.grdRecipients.TextMatrix(lRecipient, 4))
sMessage = Replace(sMessage, "<" & gsPhonebookVariableField(2, 3) & ">", frmSMSBlaster.grdRecipients.TextMatrix(lRecipient, 4))

sMessage = Replace(sMessage, "<" & LoadLanguageSpecificString(1, 213) & ">", frmSMSBlaster.grdRecipients.TextMatrix(lRecipient, 2))
sMessage = Replace(sMessage, "<" & LoadLanguageSpecificString(2, 213) & ">", frmSMSBlaster.grdRecipients.TextMatrix(lRecipient, 2))
sMessage = Replace(sMessage, "<" & LoadLanguageSpecificString(1, 214) & ">", frmSMSBlaster.grdRecipients.TextMatrix(lRecipient, 3))
sMessage = Replace(sMessage, "<" & LoadLanguageSpecificString(2, 214) & ">", frmSMSBlaster.grdRecipients.TextMatrix(lRecipient, 3))
sMessage = Replace(sMessage, "<" & LoadLanguageSpecificString(1, 215) & ">", frmSMSBlaster.grdRecipients.TextMatrix(lRecipient, 3))
sMessage = Replace(sMessage, "<" & LoadLanguageSpecificString(2, 215) & ">", frmSMSBlaster.grdRecipients.TextMatrix(lRecipient, 3))

bVariableMessageData = PersonalizedSMSModeUsed(sInput)
CreatePersonalizedMessageData = sMessage

End Function
Function ActualValidityPeriodWithReturnValueInMinutes(bSpecificSMSType As Boolean) As Long
Dim tValidityPeriod As ValidityPeriod

tValidityPeriod = ActualValidityPeriod()

Select Case True
  Case tValidityPeriod.bStandardPeriod = True
  ActualValidityPeriodWithReturnValueInMinutes = 0
  
  Case tValidityPeriod.bUserDefinedSettingsOnlyForSpecificSMSTypes = True And bSpecificSMSType = False
  ActualValidityPeriodWithReturnValueInMinutes = 0
  
  Case Else
  Select Case tValidityPeriod.nLifeTimeUnit
    Case 0  'Minutes
    ActualValidityPeriodWithReturnValueInMinutes = tValidityPeriod.lLifeTime
    
    Case 1  'Hours
    ActualValidityPeriodWithReturnValueInMinutes = (tValidityPeriod.lLifeTime) * 60
  End Select
  
End Select
End Function

Function PeriodicJob() As Boolean
If gtDeferredDeliveryTimeSettings.bUseDeferredDeliveryTime = True Then
  If gtDeferredDeliveryTimeSettings.bSingleSMS = True Then
    PeriodicJob = False
  End If

  If gtDeferredDeliveryTimeSettings.bPeriodicSMS = True Then
    PeriodicJob = True
  End If
Else
  PeriodicJob = False
End If

End Function

Function ProcessSendAction(cRecipientData As Collection, bVariableMessageData As Boolean, _
                           bVariableDeferredDeliveryTimeData As Boolean, lJobId As Long) As Integer

Dim lRecipient As Long
Dim sMessage As String
Dim cRecipientTemp As Recipient
Dim sVersionSpecific As String
Dim lCounter As Long
Dim lTemp As Long

Dim sMessageData As String
Dim sDeferredDeliveryTime As String

Dim sP1 As String
Dim sP2 As String
Dim sP3 As String
Dim sP4 As String
Dim sP5 As String
Dim sP6 As String
Dim sNotifyURL As String

Screen.MousePointer = vbHourglass

Set gSMS = Nothing

Set gSMS = New Booster
gSMS.Hosts = App.Path & "\smshosts.txt"
gSMS.UserKey = frmSMSBlaster.txtUserkey.Text
gSMS.Password = frmSMSBlaster.txtPassword.Text
gSMS.Originator = frmSMSBlaster.txtOriginator.Text

For Each cRecipientTemp In cRecipientData

  Select Case True
  
    Case bVariableMessageData = False And bVariableDeferredDeliveryTimeData = False
    gSMS.AddRecipient cRecipientTemp.sRecipient, cRecipientTemp.sTransactionReferenceNumber
    
    If cRecipientTemp.sDeferredDeliveryTime <> "" And gtDeferredDeliveryTimeSettings.bUseDeferredDeliveryTime = True Then
      gSMS.DeferredDeliveryTime = ConvertToASPSMSTimeFormat(cRecipientTemp.sDeferredDeliveryTime)
      gSMS.TimeZone = TimeZoneFromListBoxSetting(gtDeferredDeliveryTimeSettings.nTimeZone)
    End If
    
    Case bVariableMessageData = True And bVariableDeferredDeliveryTimeData = True
    gSMS.AddRecipientEx cRecipientTemp.sRecipient, cRecipientTemp.sTransactionReferenceNumber, _
                       cRecipientTemp.sMessageData, ConvertToASPSMSTimeFormat(cRecipientTemp.sDeferredDeliveryTime)
    
    Case bVariableMessageData = True And bVariableDeferredDeliveryTimeData = False
    gSMS.AddRecipientEx cRecipientTemp.sRecipient, cRecipientTemp.sTransactionReferenceNumber, cRecipientTemp.sMessageData
    If cRecipientTemp.sDeferredDeliveryTime <> "" Then
      gSMS.DeferredDeliveryTime = ConvertToASPSMSTimeFormat(cRecipientTemp.sDeferredDeliveryTime)
      gSMS.TimeZone = TimeZoneFromListBoxSetting(gtDeferredDeliveryTimeSettings.nTimeZone)
    End If
   
    Case bVariableMessageData = False And bVariableDeferredDeliveryTimeData = True
    gSMS.AddRecipientEx cRecipientTemp.sRecipient, cRecipientTemp.sTransactionReferenceNumber, , _
                       ConvertToASPSMSTimeFormat(cRecipientTemp.sDeferredDeliveryTime)
                       
    Case Else
    'Do nothing
    
  End Select
    
  Select Case True
  
    Case frmSMSBlaster.optSMSType(0).Value = True 'Text SMS
    If bVariableMessageData = True Then
      sMessage = cRecipientTemp.sMessageData
    Else
      sMessage = frmSMSBlaster.txtSMS.Text
    End If
    sP1 = "2"
  
    Case frmSMSBlaster.optSMSType(1).Value = True 'Operatorlogo
    sMessage = "<" & SelectedSMSType(gnLanguage) & ">"
    sP1 = "3"
  
    Case frmSMSBlaster.optSMSType(2).Value = True 'Grouplogo
    sMessage = "<" & SelectedSMSType(gnLanguage) & ">"
    sP1 = "12"
  
    Case frmSMSBlaster.optSMSType(3).Value = True 'Ringtone
    sMessage = "<" & SelectedSMSType(gnLanguage) & ">"
    sP1 = "5"
  
    Case frmSMSBlaster.optSMSType(4).Value = True 'Picturemessage
    sMessage = "<" & SelectedSMSType(gnLanguage) & ">: " & frmSMSBlaster.txtPictureMessageText.Text
    sP1 = "4"
  
    Case frmSMSBlaster.optSMSType(5).Value = True 'VCard
    sMessage = "<" & SelectedSMSType(gnLanguage) & ">"
    sP1 = "10"
  
    Case frmSMSBlaster.optSMSType(6).Value = True 'Unicode Text SMS
    sMessage = "<" & SelectedSMSType(gnLanguage) & ">"
    sP1 = "17"
      
    Case frmSMSBlaster.optSMSType(7).Value = True 'WAP Push SMS
    sMessage = "<" & SelectedSMSType(gnLanguage) & ">"
    sP1 = "18"
      
    Case frmSMSBlaster.optSMSType(8).Value = True 'Binarydata
    sMessage = "<" & SelectedSMSType(gnLanguage) & ">"
    sP1 = "6"
      
    Case frmSMSBlaster.optSMSType(9).Value = True
    VersionSpecificAction 20, , , sVersionSpecific
    sMessage = "<" & SelectedSMSType(gnLanguage) & ">"
    sP1 = sVersionSpecific
    
    Case frmSMSBlaster.optSMSType(10).Value = True
    VersionSpecificAction 21, , , sVersionSpecific
    sMessage = "<" & SelectedSMSType(gnLanguage) & ">"
    sP1 = sVersionSpecific
    
    Case frmSMSBlaster.optSMSType(11).Value = True
    VersionSpecificAction 22, , , sVersionSpecific
    sMessage = "<" & SelectedSMSType(gnLanguage) & ">"
    sP1 = sVersionSpecific
    
  End Select
  
  If gbSaveMessagesInSendLog = True Then
    SaveOutgoingMessage cRecipientTemp.sRecipient, cRecipientTemp.sRecipientName, _
                        cRecipientTemp.sTransactionReferenceNumber, sMessage, _
                        cRecipientTemp.sDeferredDeliveryTime, lJobId   'Puts Message into Sendlog
  End If
Next

'Specify OTA Deliverynotification URL
If frmSMSBlaster.chkUseOTADeliveryNotifications.Value = 1 Then
  'P2: Userkey
  sP2 = frmSMSBlaster.txtUserkey.Text

  'P3: Password
  sP3 = frmSMSBlaster.txtPassword.Text

  'P4: Phonenumber, which is used to receive notification
  sP4 = URLEncode(frmSMSBlaster.txtRecipientDeliveryNotification.Text)

  'P5: Language
  sP5 = Trim(Str$(gnLanguage))

  sNotifyURL = "http://www.aspsms.com/notifications/notify.asp?P1=" & sP1 & "&P2=" & sP2 & "&P3=" & sP3 & "&SCTS=<SCTS>&DSCTS=<DSCTS>&RSN=<RSN>&DST=<DST>&RCPNT=<RCPNT>&P4=" & sP4 & "&P5=" & sP5 & "&TRN=<TRN>"

  If frmSMSBlaster.chkDeliveryNotificationDelivered.Value = 1 Then
    gSMS.URLDeliveryNotification = sNotifyURL
  Else
    'Do nothing
  End If

  If frmSMSBlaster.chkDeliveryNotificationBuffered.Value = 1 Then
    gSMS.URLBufferedMessageNotification = sNotifyURL
  Else
    'Do nothing
  End If

  If frmSMSBlaster.chkDeliveryNotificationNotDelivered.Value = 1 Then
    gSMS.URLNonDeliveryNotification = sNotifyURL
  Else
    'Do nothing
  End If
Else   'Update Log automatically
  'Do nothing
End If

VersionSpecificAction 60, , lTemp
gSMS.AffiliateID = lTemp

Select Case True
  Case frmSMSBlaster.optSMSType(0).Value = True 'Text SMS
  If bVariableMessageData = True Then
    'Do nothing, already set
  Else
    gSMS.MessageData = frmSMSBlaster.txtSMS.Text
  End If
  If frmSMSBlaster.chkFlashingSMS.Value = 1 Then gSMS.FlashingSMS = True Else gSMS.FlashingSMS = False
  If frmSMSBlaster.chkBlinkingSMS.Value = 1 Then gSMS.BlinkingSMS = True Else gSMS.BlinkingSMS = False
  If frmSMSBlaster.chkReplaceMessage.Value = 1 Then
    gSMS.ReplaceMessage = 5
  Else
    'Do nothing
  End If
  gSMS.LifeTime = ActualValidityPeriodWithReturnValueInMinutes(False)
  gSMS.SendTextSMS
    
  Case frmSMSBlaster.optSMSType(1).Value = True 'Operatorlogo
  gSMS.MCC = Val(frmSMSBlaster.txtMCC.Text)
  gSMS.MNC = Val(frmSMSBlaster.txtMNC.Text)
  gSMS.LifeTime = ActualValidityPeriodWithReturnValueInMinutes(False)
  
  If frmSMSBlaster.chkRandomLogo.Value = 0 Then
    gSMS.BinaryFileLocation = frmSMSBlaster.txtPathLogo.Text
    gSMS.SendLogo
  Else
    gSMS.BinaryFileLocation = App.Path & "\" & Right("0000" & Trim(Str$(gnSelectedRandomLogo)), 4) & ".bmp"
    gSMS.SendLogo
  End If

  Case frmSMSBlaster.optSMSType(2).Value = True 'Grouplogo
  gSMS.LifeTime = ActualValidityPeriodWithReturnValueInMinutes(False)
  If frmSMSBlaster.chkRandomLogo.Value = 0 Then
    gSMS.BinaryFileLocation = frmSMSBlaster.txtPathLogo.Text
    gSMS.SendGroupLogo
  Else
    gSMS.BinaryFileLocation = App.Path & "\" & Right("0000" & Trim(Str$(gnSelectedRandomLogo)), 4) & ".bmp"
    gSMS.SendGroupLogo
  End If


  Case frmSMSBlaster.optSMSType(3).Value = True 'Ringtone
  gSMS.LifeTime = ActualValidityPeriodWithReturnValueInMinutes(False)
  gSMS.BinaryFileLocation = frmSMSBlaster.txtPathRingtone.Text
  gSMS.SendRingtone
  
  Case frmSMSBlaster.optSMSType(4).Value = True 'Picturemessage
  gSMS.LifeTime = ActualValidityPeriodWithReturnValueInMinutes(False)
  gSMS.MessageData = frmSMSBlaster.txtPictureMessageText.Text
  gSMS.BinaryFileLocation = frmSMSBlaster.txtPathPictureMessage.Text
  gSMS.SendPictureMessage
  
  Case frmSMSBlaster.optSMSType(5).Value = True 'VCard
  gSMS.LifeTime = ActualValidityPeriodWithReturnValueInMinutes(False)
  gSMS.VCard.Name = frmSMSBlaster.txtVCardName.Text
  gSMS.VCard.PhoneNumber = frmSMSBlaster.txtVCardPhoneNumber.Text
  If frmSMSBlaster.chkVCardBlinkingSMS.Value = 1 Then
    gSMS.BlinkingSMS = True
  Else
    gSMS.BlinkingSMS = False
  End If
  gSMS.SendVCard
    
  Case frmSMSBlaster.optSMSType(6).Value = True 'Unicode / UCS 2 Message
  gSMS.LifeTime = ActualValidityPeriodWithReturnValueInMinutes(False)
  sMessage = frmSMSBlaster.txtUnicode.Text
  gSMS.MessageData = ConvertUnicodeScreenDataToUCS2MessageData(sMessage)
  
  If frmSMSBlaster.chkFlashingSMSUnicode.Value Then
    gSMS.XSer = "020118"
  Else
    gSMS.XSer = "020108"
  End If
  
  If frmSMSBlaster.chkReplaceMessageUnicode = 1 Then
    gSMS.ReplaceMessage = 5
  Else
    'Do nothing
  End If
  gSMS.SendBinaryData
  
  Case frmSMSBlaster.optSMSType(7).Value = True 'WAP Push SMS
  gSMS.LifeTime = ActualValidityPeriodWithReturnValueInMinutes(False)
  gSMS.WAPPushSettings.Description = frmSMSBlaster.txtWAPPushSMSDescription
  gSMS.BinaryFileLocation = frmSMSBlaster.txtWAPPushSMSPicturePath
  gSMS.SendWAPPushSMS
    
  Case frmSMSBlaster.optSMSType(8).Value = True 'Binarydata
  gSMS.LifeTime = ActualValidityPeriodWithReturnValueInMinutes(False)
  sMessage = frmSMSBlaster.txtMessageData.Text  'Remove Carriage Returns
  sMessage = UCase(Replace(sMessage, vbCrLf, ""))
  gSMS.MessageData = sMessage
  gSMS.XSer = UCase(frmSMSBlaster.txtXSer.Text)
  gSMS.SendBinaryData
  
  Case frmSMSBlaster.optSMSType(9).Value = True
  VersionSpecificAction 10
   
  Case frmSMSBlaster.optSMSType(10).Value = True
  VersionSpecificAction 11
     
  Case frmSMSBlaster.optSMSType(11).Value = True
  VersionSpecificAction 12
    
End Select
Screen.MousePointer = vbDefault

If gSMS.ErrorCode <> 1 Then
  MsgBox LoadLanguageSpecificString(gnLanguage, 207) & vbCrLf & ErrorDescriptionFromASPSMSErrorCode(gnLanguage, CInt(gSMS.ErrorCode)), vbExclamation, gsApplicationName
  ProcessSendAction = False
Else
  ProcessSendAction = True
End If
gSMS.DeleteAllRecipients
  
Set gSMS = Nothing
End Function
Sub CenterForm(InputForm As Form)
'Centers Window independent of Screenresolution
If InputForm.WindowState <> 2 Then
  InputForm.Move (Screen.Width - InputForm.Width) / 2, (Screen.Height - InputForm.Height) / 2
End If
End Sub

Function CheckForDuplicatesWithinCurrentRecipients() As Boolean
Dim sOrig() As PhoneBookEntry
Dim sDest() As PhoneBookEntry
Dim i As Long
Dim sBackup As String
Dim lIndex As Long
Dim lDuplicates As Long
Dim sTemp As String
Dim sMessage As String
Dim sInfoDuplicates As String
Dim nShowDuplicates As Integer
Dim nAnswer As Integer
Const cMaxDuplicatesToShow = 20

If frmSMSBlaster.grdRecipients.Rows <= 1 Then Exit Function

ReDim tOrigPhoneBookEntry(1 To frmSMSBlaster.grdRecipients.Rows - 1) As PhoneBookEntry
ReDim tDestPhoneBookEntry(1 To frmSMSBlaster.grdRecipients.Rows - 1) As PhoneBookEntry
ReDim tFoundDuplicatesPhoneBookEntry(1 To cMaxDuplicatesToShow) As PhoneBookEntry

Screen.MousePointer = vbHourglass

'Fill Array
For i = LBound(tOrigPhoneBookEntry) To UBound(tOrigPhoneBookEntry)
  tOrigPhoneBookEntry(i).sName = frmSMSBlaster.grdRecipients.TextMatrix(i, 0)
  tOrigPhoneBookEntry(i).sNumber = frmSMSBlaster.grdRecipients.TextMatrix(i, 1)
Next

'Sort Array by PhoneNumber
QuickSortPhoneBookEntryArrayByPhoneNumber tOrigPhoneBookEntry, LBound(tOrigPhoneBookEntry), UBound(tOrigPhoneBookEntry)

'Remove Duplicates
lIndex = LBound(tOrigPhoneBookEntry)

For i = LBound(tOrigPhoneBookEntry) To UBound(tOrigPhoneBookEntry)
  If tOrigPhoneBookEntry(i).sNumber <> sBackup Then
    tDestPhoneBookEntry(lIndex) = tOrigPhoneBookEntry(i)
    lIndex = lIndex + 1
  Else
    lDuplicates = lDuplicates + 1
    If lDuplicates <= cMaxDuplicatesToShow Then
      tFoundDuplicatesPhoneBookEntry(lDuplicates) = tOrigPhoneBookEntry(i)
    End If
  End If
  sBackup = tOrigPhoneBookEntry(i).sNumber
Next

Screen.MousePointer = vbDefault

If lDuplicates > 0 Then
  If lDuplicates > cMaxDuplicatesToShow Then
    nShowDuplicates = cMaxDuplicatesToShow
  Else
    nShowDuplicates = lDuplicates
  End If
  
  For i = 1 To nShowDuplicates
    If tFoundDuplicatesPhoneBookEntry(i).sName = "" Then
      sInfoDuplicates = sInfoDuplicates & tFoundDuplicatesPhoneBookEntry(i).sNumber & vbCrLf
    Else
      sInfoDuplicates = sInfoDuplicates & tFoundDuplicatesPhoneBookEntry(i).sName & " / " & tFoundDuplicatesPhoneBookEntry(i).sNumber & vbCrLf
    End If
  Next
  If lDuplicates > nShowDuplicates Then
    sInfoDuplicates = sInfoDuplicates & LoadLanguageSpecificString(gnLanguage, 459) & vbCrLf  'And more...
  End If
  
  If lDuplicates = 1 Then
    sMessage = LoadLanguageSpecificString(gnLanguage, 453) & vbCrLf & vbCrLf & _
               sInfoDuplicates & vbCrLf & _
               LoadLanguageSpecificString(gnLanguage, 454) 'One Duplicate has been found. Remove?
  Else
  sMessage = LoadLanguageSpecificString(gnLanguage, 455) & " " & Trim(Str$(lDuplicates)) & " " & _
             LoadLanguageSpecificString(gnLanguage, 456) & vbCrLf & vbCrLf & _
             sInfoDuplicates & vbCrLf & _
               LoadLanguageSpecificString(gnLanguage, 457) 'Duplicates have been found. Remove?
  End If
  nAnswer = MsgBox(sMessage, vbQuestion Or vbOKCancel, gsApplicationName)
  If nAnswer = vbOK Then
    'Proceed
  Else
    Exit Function
  End If
Else
  CheckForDuplicatesWithinCurrentRecipients = True
  Exit Function
End If
  
End Function

Function ConvertUnicodeScreenDataToUCS2MessageData(sInput As String) As String
Dim i As Integer
Dim sTemp As String
Dim lTemp As Long
Dim sResult As String

sTemp = sInput

For i = 1 To Len(sTemp)
  lTemp = AscW(Mid(sTemp, i, 1))
  sResult = sResult & IntegerToHex(lTemp)
Next

'Cut down to 140 bytes, 70 chars
sResult = Left(sResult, 280)

ConvertUnicodeScreenDataToUCS2MessageData = sResult

End Function

Function ExportSendLogIntoTextfile(nLanguage As Integer, nOutputFile As Integer, lJobId As Long, bWriteTitle As Boolean) As Boolean
Dim sLine As String
Dim i As Integer

Dim rsMain As Recordset
Dim sField As String
Dim sEntry As String

On Error GoTo ErrorTrap

Set rsMain = gdbMain.OpenRecordset("select * from Jobs where lID = " & Str$(lJobId))

If bWriteTitle Then
  'Write Header
  sLine = LoadLanguageSpecificString(nLanguage, 551) & ": " & Now() & vbCrLf
  Put #nOutputFile, , sLine
  sLine = String(Len(sLine) - Len(vbCrLf), "-") & vbCrLf
  Put #nOutputFile, , sLine
  Put #nOutputFile, , vbCrLf
Else
  sLine = String(300, "-") & vbCrLf
  Put #nOutputFile, , sLine
  Put #nOutputFile, , vbCrLf
End If

sLine = "Job ID: " & vbTab & " " & Trim(Str$(lJobId)) & vbCrLf
Put #nOutputFile, , sLine

For i = 1 To gcnNumberOfJobRemarkFields
  sLine = GetJobRemarksFieldFromDatabase(nLanguage, i) & ": " & vbTab & rsMain("JobRemarksField" & Right("00" & Trim(Str$(i)), 2)) & vbCrLf
  Put #nOutputFile, , sLine
Next
  
'Remarks
sLine = LoadLanguageSpecificString(nLanguage, 581) & ": " & vbTab & rsMain("JobRemarksMemo") & "" & vbCrLf & vbCrLf
Put #nOutputFile, , sLine
    
'Date of Job
sLine = LoadLanguageSpecificString(nLanguage, 568) & ": " & vbTab & rsMain("FJobDate") & "" & vbCrLf
Put #nOutputFile, , sLine
    
'Number of Recipients
sLine = LoadLanguageSpecificString(nLanguage, 569) & ": " & vbTab & rsMain("FNumberOfRecipients") & "" & vbCrLf
Put #nOutputFile, , sLine
    
'Number of SMS
sLine = LoadLanguageSpecificString(nLanguage, 576) & ": " & vbTab & rsMain("FNumberOfMessages") & "" & vbCrLf
Put #nOutputFile, , sLine
    
'SMS Type
sLine = LoadLanguageSpecificString(nLanguage, 570) & ": " & vbTab & rsMain("FSMSType") & "" & vbCrLf
Put #nOutputFile, , sLine
    
'Sending Type
sLine = LoadLanguageSpecificString(nLanguage, 571) & ": " & vbTab & rsMain("FSendingType") & "" & vbCrLf
Put #nOutputFile, , sLine

'Starting Date
If rsMain("FWaitingTime") <> "" Then
  sLine = LoadLanguageSpecificString(nLanguage, 573) & ": " & vbTab & rsMain("FStartingDate") & "" & vbCrLf  'StartingDate
  Put #nOutputFile, , sLine
Else
  If rsMain("FStartingDate") <> "" Then
    sLine = LoadLanguageSpecificString(nLanguage, 604) & ": " & vbTab & rsMain("FStartingDate") & "" & vbCrLf  'DeferredDeliveryTime
    Put #nOutputFile, , sLine
  End If
End If

  
'Ending Date
If rsMain("FWaitingTime") <> "" Then
  sLine = LoadLanguageSpecificString(nLanguage, 574) & ": " & vbTab & rsMain("FEndingDate") & "" & vbCrLf
  Put #nOutputFile, , sLine
End If
  
'Waiting Time between SMS
If rsMain("FWaitingTime") <> "" Then
  sLine = LoadLanguageSpecificString(nLanguage, 575) & ": " & vbTab & rsMain("FWaitingTime") & "" & vbCrLf
  Put #nOutputFile, , sLine
End If
    
sLine = vbCrLf
Put #nOutputFile, , sLine
  
rsMain.Close
 
'Write Header
sLine = "Details" & vbCrLf
Put #nOutputFile, , sLine
sLine = String(Len(sLine) - Len(vbCrLf), "-") & vbCrLf
Put #nOutputFile, , sLine

sLine = vbCrLf
Put #nOutputFile, , sLine

sLine = LoadLanguageSpecificString(nLanguage, 600) & vbTab
sLine = sLine & LoadLanguageSpecificString(nLanguage, 601) & vbTab
sLine = sLine & LoadLanguageSpecificString(nLanguage, 602) & vbTab
sLine = sLine & LoadLanguageSpecificString(nLanguage, 603) & vbTab
sLine = sLine & LoadLanguageSpecificString(nLanguage, 604) & vbTab
sLine = sLine & LoadLanguageSpecificString(nLanguage, 605) & vbTab
sLine = sLine & LoadLanguageSpecificString(nLanguage, 606) & vbTab
sLine = sLine & LoadLanguageSpecificString(nLanguage, 611) & vbTab
sLine = sLine & LoadLanguageSpecificString(nLanguage, 612) & vbTab
sLine = sLine & LoadLanguageSpecificString(nLanguage, 607) & vbTab
sLine = sLine & LoadLanguageSpecificString(nLanguage, 613) & vbTab
sLine = sLine & LoadLanguageSpecificString(nLanguage, 608) & vbTab
sLine = sLine & LoadLanguageSpecificString(nLanguage, 609) & vbTab
sLine = sLine & LoadLanguageSpecificString(nLanguage, 610) & vbCrLf

Put #nOutputFile, , sLine

Set rsMain = gdbMain.OpenRecordset("select * from SendJournal where lJobID = " & Str$(lJobId) & " order by dSubmissionDate, lID")

Do While Not rsMain.EOF
  sLine = rsMain("sName") & vbTab
  sLine = sLine & rsMain("sRecipient") & vbTab
  sLine = sLine & rsMain("sTransactionReferenceNumber") & vbTab
  sLine = sLine & rsMain("sMessage") & vbTab
  sLine = sLine & rsMain("dDeferredDeliveryTime") & vbTab
  sLine = sLine & rsMain("dSubmissionDate") & vbTab
  sLine = sLine & rsMain("dNotificationDate") & vbTab
  sLine = sLine & rsMain("sDeliveryStatus") & vbTab
  sLine = sLine & rsMain("sDeliveryStatusText") & vbTab
  sLine = sLine & rsMain("sReasonCode") & vbTab
  sLine = sLine & rsMain("sReasonText") & vbTab
  sLine = sLine & rsMain("dNotificationDateBuffered") & vbTab
  sLine = sLine & rsMain("sReasoncodeBuffered") & vbTab
  sLine = sLine & rsMain("sReasonTextBuffered")
  
  sLine = Replace(sLine, vbCrLf, " ") & vbCrLf
  Put #nOutputFile, , sLine
  rsMain.MoveNext
Loop

rsMain.Close
ExportSendLogIntoTextfile = True
Exit Function

ErrorTrap:
ExportSendLogIntoTextfile = False
Exit Function
End Function

Function GetPhonebookVariableFieldFromDatabase(nLanguage As Integer, nIndex As Integer) As String
Dim sPhonebookVariableField As String

sPhonebookVariableField = GetSettingFromDatabase("PhonebookVariableField0" & Trim(Str$(nIndex)))

If sPhonebookVariableField = "DEFAULT" Then
  GetPhonebookVariableFieldFromDatabase = LoadLanguageSpecificString(nLanguage, 212 + nIndex)
Else
  GetPhonebookVariableFieldFromDatabase = sPhonebookVariableField
End If

End Function


Function GetJobRemarksFieldFromDatabase(nLanguage As Integer, nIndex As Integer) As String
Dim sJobRemarksField As String

sJobRemarksField = GetSettingFromDatabase("JobRemarksField0" & Trim(Str$(nIndex)))

If sJobRemarksField = "DEFAULT" Then
  VersionSpecificAction 47 + nIndex, nLanguage, , sJobRemarksField
End If

GetJobRemarksFieldFromDatabase = sJobRemarksField

End Function



Sub InitJobLogColWidthSettings()
Dim i As Integer
Dim nUsedDBFields As Integer
Dim rColWidth As Double

For i = 1 To 16
  If gtDBLogFieldsSettings.bJobLog(i) = True Then
    nUsedDBFields = nUsedDBFields + 1
  End If
Next

For i = 0 To 15
  rColWidth = Screen.Width / nUsedDBFields * 0.97
  PutSettingIntoDataBase "ColWidthJobs" & Right("00" & Trim(Str$(i)), 2), rColWidth
Next

End Sub

Sub InitSendLogColWidthSettings()
Dim i As Integer
Dim nUsedDBFields As Integer
Dim rColWidth As Double

For i = 1 To 16
  If gtDBLogFieldsSettings.bSendLog(i) = True Then
    nUsedDBFields = nUsedDBFields + 1
  End If
Next

For i = 0 To 15
  rColWidth = Screen.Width / nUsedDBFields * 0.97
  PutSettingIntoDataBase "ColWidthSendLog" & Right("00" & Trim(Str$(i)), 2), rColWidth
Next

End Sub


Function IntegerToHex(ByVal lInput As Long) As String
Dim lTemp As Long
Dim sTemp As String
Dim nNibbleMask1 As Long
Dim nNibbleMask2 As Long
Dim nNibbleMask3 As Long
Dim nNibbleMask4 As Long

'Convert to unsigned integer
lTemp = lInput And &HFFFF

nNibbleMask1 = &HF
nNibbleMask2 = &HF0
nNibbleMask3 = &HF00
nNibbleMask4 = &HF000

sTemp = NibbleDezToHex((lTemp And nNibbleMask1))
sTemp = NibbleDezToHex((lTemp And nNibbleMask2) / (&H10)) & sTemp
sTemp = NibbleDezToHex((lTemp And nNibbleMask3) / (&H100)) & sTemp
sTemp = NibbleDezToHex((lTemp And nNibbleMask4) / (&H1000)) & sTemp

IntegerToHex = sTemp
End Function

Function JobInfoCurrentTime() As Date
JobInfoCurrentTime = Now()
End Function

Function JobInfoEndingDate() As Variant
Dim lRecipientMultiplier As Long
Dim dStart As Date
Dim dEnd As Date

lRecipientMultiplier = 1
If gtDeferredDeliveryTimeSettings.bUseDeferredDeliveryTime = True Then
  If gtDeferredDeliveryTimeSettings.bSingleSMS = True Then
    JobInfoEndingDate = ""
  End If

  If gtDeferredDeliveryTimeSettings.bPeriodicSMS = True Then
    'Sending Type
    lRecipientMultiplier = Val(gtDeferredDeliveryTimeSettings.sNumberOfMessages) - 1
        
    dStart = gtDeferredDeliveryTimeSettings.sStartingDate
          
    Select Case gtDeferredDeliveryTimeSettings.nWaitingPeriod
      Case 0
      dEnd = DateAdd("s", lRecipientMultiplier * gtDeferredDeliveryTimeSettings.sWaitingTime, dStart)
            
      Case 1
      dEnd = DateAdd("n", lRecipientMultiplier * gtDeferredDeliveryTimeSettings.sWaitingTime, dStart)
      
      Case 2
      dEnd = DateAdd("h", lRecipientMultiplier * gtDeferredDeliveryTimeSettings.sWaitingTime, dStart)
      
      Case 3
      dEnd = DateAdd("d", lRecipientMultiplier * gtDeferredDeliveryTimeSettings.sWaitingTime, dStart)
      
      Case 4
      dEnd = DateAdd("ww", lRecipientMultiplier * gtDeferredDeliveryTimeSettings.sWaitingTime, dStart)
      
      Case 5
      dEnd = DateAdd("m", lRecipientMultiplier * gtDeferredDeliveryTimeSettings.sWaitingTime, dStart)
    
      Case Else
      
    End Select
    
    JobInfoEndingDate = dEnd
  Else
    JobInfoEndingDate = ""
  End If
Else
  JobInfoEndingDate = ""
End If


Exit Function

ErrorTrap:
Exit Function
End Function
Function JobInfoNumberOfMessages() As Long
Dim lCountRecipients As Long
Dim lRecipientMultiplier As Long
Dim lCountMessages As Long

'Number of Recipients
lCountRecipients = frmSMSBlaster.grdRecipients.Rows - 1

lRecipientMultiplier = 1
If gtDeferredDeliveryTimeSettings.bUseDeferredDeliveryTime = True Then
  If gtDeferredDeliveryTimeSettings.bPeriodicSMS = True Then
    lRecipientMultiplier = Val(gtDeferredDeliveryTimeSettings.sNumberOfMessages)
  End If
End If

lCountMessages = lCountRecipients * lRecipientMultiplier
JobInfoNumberOfMessages = lCountMessages
End Function
Function JobInfoNumberOfRecipients() As Long
JobInfoNumberOfRecipients = frmSMSBlaster.grdRecipients.Rows - 1
End Function


Function JobInfoSendingType(nLanguage As Integer) As String

If gtDeferredDeliveryTimeSettings.bUseDeferredDeliveryTime = True Then
  If gtDeferredDeliveryTimeSettings.bSingleSMS = True Then
    'Sending Type
    JobInfoSendingType = LoadLanguageSpecificString(nLanguage, 577)
  End If

  If gtDeferredDeliveryTimeSettings.bPeriodicSMS = True Then
    JobInfoSendingType = LoadLanguageSpecificString(nLanguage, 578)
  End If
Else
  'Sending Type
  JobInfoSendingType = LoadLanguageSpecificString(nLanguage, 579)
End If

End Function
Function JobInfoSMSType(nLanguage As Integer)
'SMS Type
JobInfoSMSType = SelectedSMSType(nLanguage)
End Function

Function JobInfoStartingDate() As Variant

If gtDeferredDeliveryTimeSettings.bUseDeferredDeliveryTime = True Then
  If gtDeferredDeliveryTimeSettings.bSingleSMS = True Then
    JobInfoStartingDate = CVDate(gtDeferredDeliveryTimeSettings.sDeliveryDate)
  End If

  If gtDeferredDeliveryTimeSettings.bPeriodicSMS = True Then
    JobInfoStartingDate = CVDate(gtDeferredDeliveryTimeSettings.sStartingDate)
  End If
Else
End If

End Function
Function JobInfoWaitingTimeBetweenMessages(nLanguage As Integer) As String
Dim sWaitingPeriodInfo As String

If gtDeferredDeliveryTimeSettings.bUseDeferredDeliveryTime = True Then
  If gtDeferredDeliveryTimeSettings.bSingleSMS = True Then
  End If

  If gtDeferredDeliveryTimeSettings.bPeriodicSMS = True Then
    
    Select Case gtDeferredDeliveryTimeSettings.nWaitingPeriod
      Case 0
      sWaitingPeriodInfo = LoadLanguageSpecificString(nLanguage, 187)
                  
      Case 1
      sWaitingPeriodInfo = LoadLanguageSpecificString(nLanguage, 188)
            
      Case 2
      sWaitingPeriodInfo = LoadLanguageSpecificString(nLanguage, 189)
            
      Case 3
      sWaitingPeriodInfo = LoadLanguageSpecificString(nLanguage, 190)
            
      Case 4
      sWaitingPeriodInfo = LoadLanguageSpecificString(nLanguage, 191)
            
      Case 5
      sWaitingPeriodInfo = LoadLanguageSpecificString(nLanguage, 192)
          
      Case Else
      
    End Select
    
    JobInfoWaitingTimeBetweenMessages = gtDeferredDeliveryTimeSettings.sWaitingTime & " " & sWaitingPeriodInfo

  End If
Else
  'Do nothing
End If

End Function

Function JobInfoWaitingTimeInfo(nLanguage As Integer) As String
Dim sWaitingTimeInfo As String
Select Case gtDeferredDeliveryTimeSettings.nWaitingPeriod
  
  Case 0
  sWaitingTimeInfo = LoadLanguageSpecificString(nLanguage, 187)
  
  Case 1
  sWaitingTimeInfo = LoadLanguageSpecificString(nLanguage, 188)
  
  Case 2
  sWaitingTimeInfo = LoadLanguageSpecificString(nLanguage, 189)
  
  Case 3
  sWaitingTimeInfo = LoadLanguageSpecificString(nLanguage, 190)
  
  Case 4
  sWaitingTimeInfo = LoadLanguageSpecificString(nLanguage, 191)
  
  Case 5
  sWaitingTimeInfo = LoadLanguageSpecificString(nLanguage, 192)
  
  Case Else
End Select

JobInfoWaitingTimeInfo = sWaitingTimeInfo
End Function

Function JobLogSQLStatement(nLanguage As Integer) As String
Dim sSQL As String
Dim sWhere As String
Dim sField As String
Dim i As Integer
       
ReDim sJobRemarksField(1 To gcnNumberOfJobRemarkFields) As String
       
For i = 1 To gcnNumberOfJobRemarkFields
  sJobRemarksField(i) = GetJobRemarksFieldFromDatabase(nLanguage, i)
Next

sSQL = sSQL & "SELECT lID as ID, "

If gtDBLogFieldsSettings.bJobLog(2) = True Then
  sSQL = sSQL & "JobRemarksField01 as [" & sJobRemarksField(1) & "], "
End If

If gtDBLogFieldsSettings.bJobLog(3) = True Then
  sSQL = sSQL & "JobRemarksField02 as [" & sJobRemarksField(2) & "], "
End If

If gtDBLogFieldsSettings.bJobLog(4) = True Then
  sSQL = sSQL & "JobRemarksField03 as [" & sJobRemarksField(3) & "], "
End If

If gtDBLogFieldsSettings.bJobLog(5) = True Then
  sSQL = sSQL & "JobRemarksField04 as [" & sJobRemarksField(4) & "], "
End If

If gtDBLogFieldsSettings.bJobLog(6) = True Then
  sSQL = sSQL & "JobRemarksField05 as [" & sJobRemarksField(5) & "], "
End If

If gtDBLogFieldsSettings.bJobLog(7) = True Then
  sSQL = sSQL & "JobRemarksField06 as [" & sJobRemarksField(6) & "], "
End If

If gtDBLogFieldsSettings.bJobLog(8) = True Then
  sSQL = sSQL & "JobRemarksMemo as [" & LoadLanguageSpecificString(nLanguage, 581) & "], "
End If

If gtDBLogFieldsSettings.bJobLog(9) = True Then
  sSQL = sSQL & "FSendingType as [" & LoadLanguageSpecificString(nLanguage, 552) & "], "
End If

If gtDBLogFieldsSettings.bJobLog(10) = True Then
  sSQL = sSQL & "FSMSType as [" & LoadLanguageSpecificString(nLanguage, 553) & "], "
End If

If gtDBLogFieldsSettings.bJobLog(11) = True Then
  sSQL = sSQL & "FJobDate as [" & LoadLanguageSpecificString(nLanguage, 554) & "], "
End If

If gtDBLogFieldsSettings.bJobLog(12) = True Then
  sSQL = sSQL & "FStartingDate as [" & LoadLanguageSpecificString(nLanguage, 555) & "], "
End If

If gtDBLogFieldsSettings.bJobLog(13) = True Then
  sSQL = sSQL & "FEndingDate as [" & LoadLanguageSpecificString(nLanguage, 556) & "], "
End If

If gtDBLogFieldsSettings.bJobLog(14) = True Then
  sSQL = sSQL & "FWaitingTime as [" & LoadLanguageSpecificString(nLanguage, 557) & "], "
End If

If gtDBLogFieldsSettings.bJobLog(15) = True Then
  sSQL = sSQL & "FNumberOfMessages as [" & LoadLanguageSpecificString(nLanguage, 558) & "], "
End If

If gtDBLogFieldsSettings.bJobLog(16) = True Then
  sSQL = sSQL & "FNumberOfRecipients as [" & LoadLanguageSpecificString(nLanguage, 559) & "], "
End If

sSQL = Left(sSQL, Len(sSQL) - 2)

sSQL = sSQL & " FROM Jobs "

For i = 1 To gcnNumberOfJobRemarkFields
  If gtJobLogFilterSettings.bJobRemarksFilterUsed(i) = True Then
    sField = "JobRemarksField" & Right("0" & Trim(Str$(i)), 2)
    sWhere = sWhere & "(" & sField & " = '" & gtJobLogFilterSettings.sJobRemarks(i) & "') and "
  Else
    'Do nothing
  End If
Next

If gtJobLogFilterSettings.bSMSTypeFilterUsed = True Then
  sWhere = sWhere & "(FSMSType = '" & gtJobLogFilterSettings.sSMSType & "') and "
End If

If gtJobLogFilterSettings.bSendingTypeFilterUsed = True Then
  sWhere = sWhere & "(FSendingType = '" & gtJobLogFilterSettings.sSendingType & "') and "
End If

If sWhere <> "" Then 'Cut off last 'and'
  sWhere = "WHERE " & Left(sWhere, Len(sWhere) - 4)
End If

JobLogSQLStatement = sSQL & sWhere & " ORDER BY lID"
End Function

Function NibbleDezToHex(nInput As Integer) As String
Select Case nInput
  Case 0 To 9
  NibbleDezToHex = Trim(Str$(nInput))
  
  Case 10
  NibbleDezToHex = "A"
  
  Case 11
  NibbleDezToHex = "B"
  
  Case 12
  NibbleDezToHex = "C"
  
  Case 13
  NibbleDezToHex = "D"
  
  Case 14
  NibbleDezToHex = "E"
  
  Case 15
  NibbleDezToHex = "F"
  
  Case Else
  '"Interner Fehler NibbleDezToHex"
  
End Select
  
End Function

Function PersonalizedSMSModeUsed(sInput As String) As Boolean
Dim bPlaceholdersUsed As Boolean
Select Case True
  Case InStr(sInput, LoadLanguageSpecificString(1, 234)) >= 1
  bPlaceholdersUsed = True
  
  Case InStr(sInput, LoadLanguageSpecificString(2, 234)) >= 1
  bPlaceholdersUsed = True
  
  Case InStr(sInput, LoadLanguageSpecificString(1, 235)) >= 1
  bPlaceholdersUsed = True
  
  Case InStr(sInput, LoadLanguageSpecificString(2, 235)) >= 1
  bPlaceholdersUsed = True
  
  Case InStr(sInput, "<" & LoadLanguageSpecificString(1, 213) & ">") >= 1
  bPlaceholdersUsed = True
  
  Case InStr(sInput, "<" & LoadLanguageSpecificString(2, 213) & ">") >= 1
  bPlaceholdersUsed = True
  
  Case InStr(sInput, "<" & LoadLanguageSpecificString(1, 214) & ">") >= 1
  bPlaceholdersUsed = True
  
  Case InStr(sInput, "<" & LoadLanguageSpecificString(2, 214) & ">") >= 1
  bPlaceholdersUsed = True
  
  Case InStr(sInput, "<" & LoadLanguageSpecificString(1, 215) & ">") >= 1
  bPlaceholdersUsed = True
  
  Case InStr(sInput, "<" & LoadLanguageSpecificString(2, 215) & ">") >= 1
  bPlaceholdersUsed = True
  
  Case InStr(sInput, "<" & LoadLanguageSpecificString(1, 216) & ">") >= 1
  bPlaceholdersUsed = True
  
  Case InStr(sInput, "<" & LoadLanguageSpecificString(2, 216) & ">") >= 1
  bPlaceholdersUsed = True
  
  Case InStr(sInput, "<" & gsPhonebookVariableField(1, 1) & ">") >= 1
  bPlaceholdersUsed = True
  
  Case InStr(sInput, "<" & gsPhonebookVariableField(2, 1) & ">") >= 1
  bPlaceholdersUsed = True
  
  Case InStr(sInput, "<" & gsPhonebookVariableField(1, 2) & ">") >= 1
  bPlaceholdersUsed = True
  
  Case InStr(sInput, "<" & gsPhonebookVariableField(2, 2) & ">") >= 1
  bPlaceholdersUsed = True
  
  Case InStr(sInput, "<" & gsPhonebookVariableField(1, 3) & ">") >= 1
  bPlaceholdersUsed = True
  
  Case InStr(sInput, "<" & gsPhonebookVariableField(2, 3) & ">") >= 1
  bPlaceholdersUsed = True

End Select

If bPlaceholdersUsed = True Then
  PersonalizedSMSModeUsed = True
Else
  PersonalizedSMSModeUsed = False
End If

End Function

Function PhonebookSQLStatement() As String
Dim sSQL As String
Dim sTemp As String

sTemp = frmSMSBlaster.txtFilter.Text
sTemp = Replace(sTemp, "'", "")

If sTemp <> "" Then
  sSQL = "SELECT ID, "
  sSQL = sSQL & "sName as [" & LoadLanguageSpecificString(gnLanguage, 196) & "], "
  sSQL = sSQL & "sNumber as [" & LoadLanguageSpecificString(gnLanguage, 197) & "], "
  sSQL = sSQL & "Variable1 as [" & gsPhonebookVariableField(gnLanguage, 1) & "], "
  sSQL = sSQL & "Variable2 as [" & gsPhonebookVariableField(gnLanguage, 2) & "], "
  sSQL = sSQL & "Variable3 as [" & gsPhonebookVariableField(gnLanguage, 3) & "] "
  sSQL = sSQL & "FROM Phonebook "
  sSQL = sSQL & "WHERE sName like '*" & sTemp & "*' or "
  sSQL = sSQL & "sNumber like '*" & sTemp & "*' or "
  sSQL = sSQL & "Variable1 like '*" & sTemp & "*' or "
  sSQL = sSQL & "Variable2 like '*" & sTemp & "*' or "
  sSQL = sSQL & "Variable3 like '*" & sTemp & "*' "
  sSQL = sSQL & SQLOrderPartFromPhonebookOrder()
Else
  sSQL = "SELECT ID, "
  sSQL = sSQL & "sName as [" & LoadLanguageSpecificString(gnLanguage, 196) & "], "
  sSQL = sSQL & "sNumber as [" & LoadLanguageSpecificString(gnLanguage, 197) & "], "
  sSQL = sSQL & "Variable1 as [" & gsPhonebookVariableField(gnLanguage, 1) & "], "
  sSQL = sSQL & "Variable2 as [" & gsPhonebookVariableField(gnLanguage, 2) & "], "
  sSQL = sSQL & "Variable3 as [" & gsPhonebookVariableField(gnLanguage, 3) & "] "
  sSQL = sSQL & "FROM Phonebook " & SQLOrderPartFromPhonebookOrder()
End If
PhonebookSQLStatement = sSQL
End Function

Sub PutJobRemarksFieldIntoDatabase(nLanguage As Integer, nIndex As Integer, sJobRemarksField As String)
Dim sTemp As String

VersionSpecificAction 47 + nIndex, nLanguage, , sTemp

If sJobRemarksField = sTemp Then
  PutSettingIntoDataBase "JobRemarksField" & Right("00" & Trim(Str$(nIndex)), 2), "DEFAULT"
Else
  PutSettingIntoDataBase "JobRemarksField" & Right("00" & Trim(Str$(nIndex)), 2), sJobRemarksField
End If

End Sub

Sub QuickSortPhoneBookEntryArrayByName(sInputArray() As PhoneBookEntry, l As Long, R As Long)
Dim i As Long
Dim j As Long
Dim x As PhoneBookEntry
Dim tPhoneBookEntryTemp As PhoneBookEntry

i = l
j = R
x = sInputArray((l + R) / 2)
While (i <= j)
While (sInputArray(i).sName < x.sName And i < R)
  i = i + 1
Wend

While (x.sName < sInputArray(j).sName And j > l)
  j = j - 1
Wend

If (i <= j) Then
  tPhoneBookEntryTemp = sInputArray(i)           'Swap
  sInputArray(i) = sInputArray(j)                'Swap
  sInputArray(j) = tPhoneBookEntryTemp           'Swap
  i = i + 1
  j = j - 1
End If
Wend

If (l < j) Then Call QuickSortPhoneBookEntryArrayByName(sInputArray(), l, j)
If (i < R) Then Call QuickSortPhoneBookEntryArrayByName(sInputArray(), i, R)

End Sub


Sub QuickSortPhoneBookEntryArrayByPhoneNumber(sInputArray() As PhoneBookEntry, l As Long, R As Long)
Dim i As Long
Dim j As Long
Dim x As PhoneBookEntry
Dim tPhoneBookEntryTemp As PhoneBookEntry

i = l
j = R
x = sInputArray((l + R) / 2)
While (i <= j)
While (sInputArray(i).sNumber < x.sNumber And i < R)
  i = i + 1
Wend

While (x.sNumber < sInputArray(j).sNumber And j > l)
  j = j - 1
Wend

If (i <= j) Then
  tPhoneBookEntryTemp = sInputArray(i)           'Swap
  sInputArray(i) = sInputArray(j)                'Swap
  sInputArray(j) = tPhoneBookEntryTemp           'Swap
  i = i + 1
  j = j - 1
End If
Wend

If (l < j) Then Call QuickSortPhoneBookEntryArrayByPhoneNumber(sInputArray(), l, j)
If (i < R) Then Call QuickSortPhoneBookEntryArrayByPhoneNumber(sInputArray(), i, R)

End Sub



Function ErrorDescriptionFromASPSMSErrorCode(nLanguage As Integer, nErrorCode As Integer) As String
Select Case nErrorCode

  Case gcErrorCodeConnectFailed
  ErrorDescriptionFromASPSMSErrorCode = LoadLanguageSpecificString(nLanguage, 420)
  
  Case gcErrorCodeAuthorizationFailed
  ErrorDescriptionFromASPSMSErrorCode = LoadLanguageSpecificString(nLanguage, 421)
  
  Case gcErrorCodeBinaryFileNotFound
  ErrorDescriptionFromASPSMSErrorCode = LoadLanguageSpecificString(nLanguage, 422)
  
  Case gcErrorCodeNotEnoughCreditsAvailable
  ErrorDescriptionFromASPSMSErrorCode = LoadLanguageSpecificString(nLanguage, 423)
  
  Case gcErrorCodeTimeOutError
  ErrorDescriptionFromASPSMSErrorCode = LoadLanguageSpecificString(nLanguage, 424)
  
  Case gcErrorCodeTransmissionErrorTryAgain
  ErrorDescriptionFromASPSMSErrorCode = LoadLanguageSpecificString(nLanguage, 425)
  
  Case gcErrorCodeInvalidUserKey
  ErrorDescriptionFromASPSMSErrorCode = LoadLanguageSpecificString(nLanguage, 426)
  
  Case gcErrorCodeInvalidPassword
  ErrorDescriptionFromASPSMSErrorCode = LoadLanguageSpecificString(nLanguage, 427)
  
  Case gcErrorCodeInvalidOriginator
  ErrorDescriptionFromASPSMSErrorCode = LoadLanguageSpecificString(nLanguage, 428)
  
  Case gcErrorCodeInvalidMessageData
  ErrorDescriptionFromASPSMSErrorCode = LoadLanguageSpecificString(nLanguage, 429)
  
  Case gcErrorCodeInvalidBinaryData
  ErrorDescriptionFromASPSMSErrorCode = LoadLanguageSpecificString(nLanguage, 430)
  
  Case gcErrorCodeInvalidBinaryFile
  ErrorDescriptionFromASPSMSErrorCode = LoadLanguageSpecificString(nLanguage, 431)
  
  Case gcErrorCodeInvalidMCC
  ErrorDescriptionFromASPSMSErrorCode = LoadLanguageSpecificString(nLanguage, 432)
  
  Case gcErrorCodeInvalidMNC
  ErrorDescriptionFromASPSMSErrorCode = LoadLanguageSpecificString(nLanguage, 433)
  
  Case gcErrorCodeInvalidxSer
  ErrorDescriptionFromASPSMSErrorCode = LoadLanguageSpecificString(nLanguage, 434)
  
  Case gcErrorCodeInvalidURLBufferedMessageNotification
  ErrorDescriptionFromASPSMSErrorCode = LoadLanguageSpecificString(nLanguage, 435)
  
  Case gcErrorCodeInvalidURLDeliveryNotification
  ErrorDescriptionFromASPSMSErrorCode = LoadLanguageSpecificString(nLanguage, 436)
  
  Case gcErrorCodeInvalidURLNonDeliveryNotification
  ErrorDescriptionFromASPSMSErrorCode = LoadLanguageSpecificString(nLanguage, 437)
  
  Case gcErrorCodeMissingRecipient
  ErrorDescriptionFromASPSMSErrorCode = LoadLanguageSpecificString(nLanguage, 438)
  
  Case gcErrorCodeMissingBinaryData
  ErrorDescriptionFromASPSMSErrorCode = LoadLanguageSpecificString(nLanguage, 439)
  
  Case gcErrorCodeInvalidDeferredDeliveryTime
  ErrorDescriptionFromASPSMSErrorCode = LoadLanguageSpecificString(nLanguage, 440)
  
  Case gcErrorCodeMissingTransactionReferenceNumber
  ErrorDescriptionFromASPSMSErrorCode = LoadLanguageSpecificString(nLanguage, 441)
  
  Case gcErrorCodeServiceTemporaryNotAvailable
  ErrorDescriptionFromASPSMSErrorCode = LoadLanguageSpecificString(nLanguage, 442)
  
  Case gcErrorCodeUserBarringActive
  ErrorDescriptionFromASPSMSErrorCode = LoadLanguageSpecificString(nLanguage, 443)
  
  Case gcErrorCodeNotAuthorizedForThisOperation
  ErrorDescriptionFromASPSMSErrorCode = LoadLanguageSpecificString(nLanguage, 444)
  
  Case gcErrorCodeMessageTooLong
  ErrorDescriptionFromASPSMSErrorCode = LoadLanguageSpecificString(nLanguage, 445)
  
  Case gcErrorCodeNoOriginatorRestrictions
  ErrorDescriptionFromASPSMSErrorCode = LoadLanguageSpecificString(nLanguage, 446)
  
  Case gcErrorCodeOriginatorAuthorizationPending
  ErrorDescriptionFromASPSMSErrorCode = LoadLanguageSpecificString(nLanguage, 447)
  
  Case gcErrorCodeOriginatorNotAuthorized
  ErrorDescriptionFromASPSMSErrorCode = LoadLanguageSpecificString(nLanguage, 448)
  
  Case gcErrorCodeOriginatorAlreadyAuthorized
  ErrorDescriptionFromASPSMSErrorCode = LoadLanguageSpecificString(nLanguage, 449)
    
  Case Else
  
End Select
End Function

Function FieldExists(rsInput As Recordset, sField As String) As Boolean
Dim vTemp As Variant
On Error GoTo ErrorTrap

vTemp = rsInput(sField)

FieldExists = True

Exit Function
ErrorTrap:

FieldExists = False
Exit Function
End Function


Sub RefreshImportCounter()
frmImport.fraImport.Caption = LoadLanguageSpecificString(gnLanguage, 641) & " / " & Trim(Str$(frmImport.grdImport.Rows)) & " " & LoadLanguageSpecificString(gnLanguage, 642)
End Sub

Sub RestoreJobInfoSettings()
Dim i As Integer

For i = 1 To gcnNumberOfJobRemarkFields
  UpdateComboBoxRemarksfrmSMSBlaster i
Next

For i = 1 To gcnNumberOfJobRemarkFields
  frmSMSBlaster.cboJobRemarks(i).Text = GetSettingFromDatabase("JobRemarksDefault" & Right("00" & Trim(Str$(i)), 2))
Next

RestoreOTANotificationSettings

End Sub

Sub RestoreLogSettings()
Dim sRelevantSetting As String
Dim i As Integer

For i = 1 To 16
  sRelevantSetting = "SendLogFieldEnabled" & Right("00" & Trim(Str$(i)), 2)
  gtDBLogFieldsSettings.bSendLog(i) = GetSettingFromDatabase(sRelevantSetting)
  
  sRelevantSetting = "JobLogFieldEnabled" & Right("00" & Trim(Str$(i)), 2)
  gtDBLogFieldsSettings.bJobLog(i) = GetSettingFromDatabase(sRelevantSetting)
Next

End Sub

Sub RestoreOTANotificationSettings()
If GetSettingFromDatabase("OTANotificationSettingsUseService") = True Then
  frmSMSBlaster.chkUseOTADeliveryNotifications.Value = 1
Else
  frmSMSBlaster.chkUseOTADeliveryNotifications.Value = 0
End If

frmSMSBlaster.txtRecipientDeliveryNotification.Text = GetSettingFromDatabase("OTANotificationSettingsMobilenumber")

If GetSettingFromDatabase("OTANotificationSettingsEventBuffered") = True Then
  frmSMSBlaster.chkDeliveryNotificationBuffered.Value = 1
Else
  frmSMSBlaster.chkDeliveryNotificationBuffered.Value = 0
End If

If GetSettingFromDatabase("OTANotificationSettingsEventDelivered") = True Then
  frmSMSBlaster.chkDeliveryNotificationDelivered.Value = 1
Else
  frmSMSBlaster.chkDeliveryNotificationDelivered.Value = 0
End If

If GetSettingFromDatabase("OTANotificationSettingsEventNotDelivered") = True Then
  frmSMSBlaster.chkDeliveryNotificationNotDelivered.Value = 1
Else
  frmSMSBlaster.chkDeliveryNotificationNotDelivered.Value = 0
End If
End Sub

Function SaveCurrentJobInfo(nLanguage As Integer) As Long
Dim rsMain As Recordset
Dim sField As String
Dim sEntry As String
Dim i As Integer

On Error GoTo ErrorTrap

Set rsMain = gdbMain.OpenRecordset("select * from Jobs order by lID")

rsMain.AddNew
  For i = 1 To gcnNumberOfJobRemarkFields
    rsMain("JobRemarksField" & Right("00" & Trim(Str$(i)), 2)) = Left(frmSMSBlaster.cboJobRemarks(i).Text, 80)
  Next
  rsMain("JobRemarksMemo") = frmSMSBlaster.txtJobRemarksMemo.Text
  rsMain("FSendingType") = JobInfoSendingType(nLanguage)
  rsMain("FSMSType") = JobInfoSMSType(nLanguage)
  rsMain("FJobDate") = JobInfoCurrentTime()

  If JobInfoStartingDate() <> "" Then
    rsMain("FStartingDate") = JobInfoStartingDate()
  End If
  
  If JobInfoEndingDate() <> "" Then
    rsMain("FEndingDate") = JobInfoEndingDate()
  End If
  rsMain("FWaitingTime") = JobInfoWaitingTimeBetweenMessages(nLanguage)
  rsMain("FNumberOfMessages") = JobInfoNumberOfMessages()
  rsMain("FNumberOfRecipients") = JobInfoNumberOfRecipients()

rsMain.Update
rsMain.MoveLast
SaveCurrentJobInfo = rsMain("lID")

rsMain.Close

Exit Function
ErrorTrap:
Exit Function

End Function
Sub SetListIndexWithText(cboInput As ComboBox, sText As String)
Dim nListIndex As Integer
Dim bFound As Boolean

If sText <> "" Then
  cboInput.Text = sText
Else
  nListIndex = 0
  Do While Not bFound And (nListIndex + 1) <= cboInput.ListCount
    If cboInput.List(nListIndex) = sText Then
      cboInput.ListIndex = nListIndex
      bFound = True
    End If
    nListIndex = nListIndex + 1
  Loop
End If

End Sub

Function SQLOrderPartFromPhonebookOrder() As String
Select Case gnPhoneBookSortOrder

  Case 1
  SQLOrderPartFromPhonebookOrder = " order by sName asc"
  
  Case 2
  SQLOrderPartFromPhonebookOrder = " order by sName desc"
   
  Case 3
  SQLOrderPartFromPhonebookOrder = " order by sNumber asc"
  
  Case 4
  SQLOrderPartFromPhonebookOrder = " order by sNumber desc"
  
  Case Else
  gnPhoneBookSortOrder = 1
  SQLOrderPartFromPhonebookOrder = SQLOrderPartFromPhonebookOrder()
  
End Select
  
End Function

Function SQLValidCharsEncode(sInput As String) As String
Const cValidChars = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789/()"

Dim i As Integer
Dim sResult As String
Dim sTemp As String

If Len(sInput) > 0 Then
  For i = 1 To Len(sInput)
    sTemp = Mid(sInput, i, 1)
    If InStr(1, cValidChars, sTemp, vbBinaryCompare) = 0 Then
      sTemp = " "
    End If
    sResult = sResult & sTemp
  Next
SQLValidCharsEncode = sResult
End If

End Function

Function TrimValidityPeriodToCorrectValues(tValidityPeriod As ValidityPeriod) As ValidityPeriod
Dim tValidityPeriodTemp As ValidityPeriod

tValidityPeriodTemp = tValidityPeriod
tValidityPeriodTemp.nLifeTimeUnit = tValidityPeriod.nLifeTimeUnit
tValidityPeriodTemp.bStandardPeriod = tValidityPeriod.bStandardPeriod
tValidityPeriodTemp.bUserDefinedSettingsOnlyForSpecificSMSTypes = tValidityPeriod.bUserDefinedSettingsOnlyForSpecificSMSTypes

Select Case tValidityPeriod.nLifeTimeUnit
  Case 0  'Minutes
  If tValidityPeriod.lLifeTime < 3 Then
    tValidityPeriodTemp.lLifeTime = 3
  End If
  If tValidityPeriod.lLifeTime > 1440 Then
    tValidityPeriodTemp.nLifeTimeUnit = 1
    tValidityPeriodTemp.lLifeTime = 24
  End If
    
  Case 1  'Hours
  If tValidityPeriod.lLifeTime < 1 Then
    tValidityPeriodTemp.nLifeTimeUnit = 0
    tValidityPeriodTemp.lLifeTime = 3
  End If
  If tValidityPeriod.lLifeTime > 24 Then
    tValidityPeriodTemp.lLifeTime = 24
  End If
End Select

TrimValidityPeriodToCorrectValues = tValidityPeriodTemp
End Function

Sub UpdateComboBoxRemarksfrmSMSBlaster(nIndex As Integer)
Dim rsMain As Recordset
Dim sField As String
Dim sEntry As String
Dim sSelectedField As String

On Error GoTo ErrorTrap

sField = "JobRemarksField" & Right("0" & Trim(Str$(nIndex)), 2)

Set rsMain = gdbMain.OpenRecordset("select " & sField & " from Jobs group by " & sField & " order by " & sField)

sSelectedField = frmSMSBlaster.cboJobRemarks(nIndex).Text

If rsMain.BOF And rsMain.EOF Then
  'Do nothing
Else
  frmSMSBlaster.cboJobRemarks(nIndex).Clear
  Do While Not rsMain.EOF
    sEntry = rsMain(sField) & ""
    frmSMSBlaster.cboJobRemarks(nIndex).AddItem sEntry
    rsMain.MoveNext
  Loop
End If

frmSMSBlaster.cboJobRemarks(nIndex).Text = sSelectedField

rsMain.Close

Exit Sub
ErrorTrap:
Exit Sub
End Sub
Sub UpdateComboBoxfrmFilterJoblog(nIndex As Integer, cboInput As ComboBox, sFieldInput As String)
Dim rsMain As Recordset
Dim sField As String
Dim sEntry As String
Dim sSelectedField As String

On Error GoTo ErrorTrap

If nIndex = -1 Then
  sField = sFieldInput
Else
  sField = sFieldInput & Right("0" & Trim(Str$(nIndex)), 2)
End If

Set rsMain = gdbMain.OpenRecordset("select " & sField & " from Jobs group by " & sField & " order by " & sField)

If rsMain.BOF And rsMain.EOF Then
  'Do nothing
Else
  cboInput.Clear
  cboInput.AddItem LoadLanguageSpecificString(gnLanguage, 321)
  cboInput.ItemData(cboInput.NewIndex) = gcNoFilter

  Do While Not rsMain.EOF
    sEntry = rsMain(sField) & ""
    cboInput.AddItem sEntry
    rsMain.MoveNext
  Loop
End If

rsMain.Close

Exit Sub
ErrorTrap:
Exit Sub
End Sub

Sub UpdateJobInfoScreen(nLanguage As Integer)
Dim sWaitingPeriodInfo As String
Dim lCountRecipients As Long
Dim lRecipientMultiplier As Long
Dim lCountMessages As Long
Dim dStart As Date
Dim dEnd As Date

'CurrentTime
frmSMSBlaster.lblAutoGeneratedRemarks(1).Caption = LoadLanguageSpecificString(nLanguage, 568) & ": " & JobInfoCurrentTime

'Number of Recipients
lCountRecipients = frmSMSBlaster.grdRecipients.Rows - 1
frmSMSBlaster.lblAutoGeneratedRemarks(2).Caption = LoadLanguageSpecificString(nLanguage, 569) & ": " & Trim(Str$(JobInfoNumberOfRecipients))

'SMS Type
frmSMSBlaster.lblAutoGeneratedRemarks(4).Caption = LoadLanguageSpecificString(nLanguage, 570) & ": " & JobInfoSMSType(nLanguage)

'Sending Type
frmSMSBlaster.lblAutoGeneratedRemarks(5).Caption = ""

'Starting Date or Delivery Date
frmSMSBlaster.lblAutoGeneratedRemarks(6).Caption = ""

'Ending Date

'Waiting Time between Messages

lRecipientMultiplier = 1
If gtDeferredDeliveryTimeSettings.bUseDeferredDeliveryTime = True Then
  If gtDeferredDeliveryTimeSettings.bSingleSMS = True Then
    'Sending Type
    frmSMSBlaster.lblAutoGeneratedRemarks(5).Caption = LoadLanguageSpecificString(nLanguage, 571) & ": " & JobInfoSendingType(nLanguage)
    'Starting Date or Delivery Date
    frmSMSBlaster.lblAutoGeneratedRemarks(6).Caption = LoadLanguageSpecificString(nLanguage, 572) & ": " & gtDeferredDeliveryTimeSettings.sDeliveryDate
    frmSMSBlaster.lblAutoGeneratedRemarks(6).Visible = True
    frmSMSBlaster.lblAutoGeneratedRemarks(7).Visible = False
    frmSMSBlaster.lblAutoGeneratedRemarks(8).Visible = False
  End If

  If gtDeferredDeliveryTimeSettings.bPeriodicSMS = True Then
    'Sending Type
    lRecipientMultiplier = Val(gtDeferredDeliveryTimeSettings.sNumberOfMessages)
    frmSMSBlaster.lblAutoGeneratedRemarks(5).Caption = LoadLanguageSpecificString(nLanguage, 571) & ": " & JobInfoSendingType(nLanguage)
    frmSMSBlaster.lblAutoGeneratedRemarks(6).Caption = LoadLanguageSpecificString(nLanguage, 573) & ": " & JobInfoStartingDate()
    
    dStart = gtDeferredDeliveryTimeSettings.sStartingDate
          
    dEnd = JobInfoEndingDate()
    
    frmSMSBlaster.lblAutoGeneratedRemarks(7).Caption = LoadLanguageSpecificString(nLanguage, 574) & ": " & dEnd
    frmSMSBlaster.lblAutoGeneratedRemarks(8).Caption = LoadLanguageSpecificString(nLanguage, 575) & ": " & gtDeferredDeliveryTimeSettings.sWaitingTime & " " & JobInfoWaitingTimeInfo(nLanguage)
    frmSMSBlaster.lblAutoGeneratedRemarks(6).Visible = True
    frmSMSBlaster.lblAutoGeneratedRemarks(7).Visible = True
    frmSMSBlaster.lblAutoGeneratedRemarks(8).Visible = True
  End If
Else
  'Sending Type
  frmSMSBlaster.lblAutoGeneratedRemarks(5).Caption = LoadLanguageSpecificString(nLanguage, 571) & ": " & JobInfoSendingType(nLanguage)
  frmSMSBlaster.lblAutoGeneratedRemarks(6).Visible = False
  frmSMSBlaster.lblAutoGeneratedRemarks(7).Visible = False
  frmSMSBlaster.lblAutoGeneratedRemarks(8).Visible = False
End If

'Number of Messages
frmSMSBlaster.lblAutoGeneratedRemarks(3).Caption = LoadLanguageSpecificString(nLanguage, 576) & ": " & Trim(Str$(JobInfoNumberOfMessages))


Exit Sub
End Sub
Function URLEncode(sInput As String) As String
Const cValidChars = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789"

Dim i As Integer
Dim sResult As String
Dim sTemp As String

If Len(sInput) > 0 Then
  For i = 1 To Len(sInput)
    sTemp = Mid(sInput, i, 1)
    If InStr(1, cValidChars, sTemp, vbBinaryCompare) = 0 Then
      sTemp = "%" & Right("00" & Hex(Asc(sTemp)), 2)
    End If
    sResult = sResult & sTemp
  Next
URLEncode = sResult
End If
End Function


Sub LoadSavedRandomLogosOnScreen()
Dim i As Integer
Dim sFilename As String

On Error Resume Next

For i = 0 To 20
  sFilename = App.Path & "\" & Right("0000" & Trim(Str$(i)), 4) & ".bmp"
  frmSMSBlaster.imgRandomLogo(i).Picture = LoadPicture(sFilename)
Next

frmSMSBlaster.imgRandomLogo_Click 0
gnSelectedRandomLogo = 0
End Sub
Function NumberOfRemainingCharsInLastConcatenationPart(nLenght As Integer, bBlinkingSMS As Boolean, bBlinkingTagSet As Boolean) As Integer
Dim nTemp As Integer
Dim nLengthWork As Integer
Dim nLenghtFirstSMS As Integer
Dim nLenghtConcatenationPart As Integer
Dim nLenghtSMS As Integer
Dim nUsedCharsWithinThisPart As Integer

'Explanation of this function
'1 SMS may consist out of up to 160 chars
'If several SMS are concatenated together, the lenght of each concatenationpart has to be reduced to 153 chars, because
'the concatenation infoheader also takes space
'Similar explanation for blinking SMS

If bBlinkingSMS = True Then
  If bBlinkingTagSet = True Then
    nLengthWork = nLenght
  Else
    nLengthWork = nLenght + 1 'Because in this case BlinkingTag will be automatically set and needs one char
  End If
Else
  nLengthWork = nLenght
End If

If bBlinkingSMS = False Then
  nLenghtFirstSMS = 160
  nLenghtConcatenationPart = 153
Else
  nLenghtFirstSMS = 70
  nLenghtConcatenationPart = 66
End If

If nLengthWork > nLenghtFirstSMS Then
  nUsedCharsWithinThisPart = nLengthWork Mod nLenghtConcatenationPart
  nLenghtSMS = nLenghtConcatenationPart
Else
  nUsedCharsWithinThisPart = nLengthWork Mod nLenghtFirstSMS
  nLenghtSMS = nLenghtFirstSMS
End If

Select Case True
  Case nUsedCharsWithinThisPart <> 0
  NumberOfRemainingCharsInLastConcatenationPart = nLenghtSMS - nUsedCharsWithinThisPart
  
  Case nLengthWork = 0
  NumberOfRemainingCharsInLastConcatenationPart = nLenghtSMS
  
  Case Else
  NumberOfRemainingCharsInLastConcatenationPart = 0
  
End Select

End Function
Function NumberOfConcatenationParts(nLenght As Integer, bBlinkingSMS As Boolean) As Integer
Dim nTemp As Integer
Dim nLenghtOneSMS As Integer
Dim nLenghtConcatenationPart As Integer

If bBlinkingSMS = False Then
  nLenghtOneSMS = 160
  nLenghtConcatenationPart = 153
Else
  nLenghtOneSMS = 70
  nLenghtConcatenationPart = 66
End If
  
If nLenght > nLenghtOneSMS Then
  If nLenght Mod nLenghtConcatenationPart = 0 Then
    NumberOfConcatenationParts = nLenght / nLenghtConcatenationPart
  Else
    NumberOfConcatenationParts = Int((nLenght / nLenghtConcatenationPart) + 1)
  End If
Else
  NumberOfConcatenationParts = 1
End If
End Function


Sub AdjustFontControls(frmInput As Form)
Dim tFontSettingsTemp As FontSettings
Dim Control As Object
Dim i As Integer
Dim bExpectedFontFound As Boolean
Dim sFont As String

If gtFontSettingsCurrent.bSpecificFontUsed = False Then
  tFontSettingsTemp = gtFontSettingsDefault
Else
  tFontSettingsTemp = gtFontSettingsCurrent
End If

frmInput.Font.Name = tFontSettingsTemp.sFontName
frmInput.Font.Size = tFontSettingsTemp.rFontSize
frmInput.Font.Bold = tFontSettingsTemp.bFontBold
frmInput.Font.Italic = tFontSettingsTemp.bFontItalic

For Each Control In frmInput.Controls
  
  Select Case True
  
    Case TypeOf Control Is CommandButton
    Control.Font.Name = tFontSettingsTemp.sFontName
    Control.Font.Size = tFontSettingsTemp.rFontSize
    Control.Font.Bold = tFontSettingsTemp.bFontBold
    Control.Font.Italic = tFontSettingsTemp.bFontItalic
      
    Case TypeOf Control Is Label
    Control.Font.Name = tFontSettingsTemp.sFontName
    Control.Font.Size = tFontSettingsTemp.rFontSize
    Control.Font.Bold = tFontSettingsTemp.bFontBold
    Control.Font.Italic = tFontSettingsTemp.bFontItalic
    
    Case TypeOf Control Is Frame
    Control.Font.Name = tFontSettingsTemp.sFontName
    Control.Font.Size = tFontSettingsTemp.rFontSize
    Control.Font.Bold = tFontSettingsTemp.bFontBold
    Control.Font.Italic = tFontSettingsTemp.bFontItalic
    
    Case TypeOf Control Is TextBox
    Control.Font.Name = tFontSettingsTemp.sFontName
    Control.Font.Size = tFontSettingsTemp.rFontSize
    Control.Font.Bold = tFontSettingsTemp.bFontBold
    Control.Font.Italic = tFontSettingsTemp.bFontItalic
    
    Case TypeOf Control Is CheckBox
    Control.Font.Name = tFontSettingsTemp.sFontName
    Control.Font.Size = tFontSettingsTemp.rFontSize
    Control.Font.Bold = tFontSettingsTemp.bFontBold
    Control.Font.Italic = tFontSettingsTemp.bFontItalic
    
    Case TypeOf Control Is OptionButton
    Control.Font.Name = tFontSettingsTemp.sFontName
    Control.Font.Size = tFontSettingsTemp.rFontSize
    Control.Font.Bold = tFontSettingsTemp.bFontBold
    Control.Font.Italic = tFontSettingsTemp.bFontItalic
    
    Case TypeOf Control Is ComboBox
    Control.Font.Name = tFontSettingsTemp.sFontName
    Control.Font.Size = tFontSettingsTemp.rFontSize
    Control.Font.Bold = tFontSettingsTemp.bFontBold
    Control.Font.Italic = tFontSettingsTemp.bFontItalic
    
    Case TypeOf Control Is ListBox
    Control.Font.Name = tFontSettingsTemp.sFontName
    Control.Font.Size = tFontSettingsTemp.rFontSize
    Control.Font.Bold = tFontSettingsTemp.bFontBold
    Control.Font.Italic = tFontSettingsTemp.bFontItalic
    
    Case TypeOf Control Is MSFlexGrid
    Control.Font = tFontSettingsTemp.sFontName
    Control.Font.Size = tFontSettingsTemp.rFontSize
    Control.Font.Bold = tFontSettingsTemp.bFontBold
    Control.Font.Italic = tFontSettingsTemp.bFontItalic
    
    Case TypeOf Control Is SSTab
    Control.Font = tFontSettingsTemp.sFontName
    Control.Font.Size = tFontSettingsTemp.rFontSize
    Control.Font.Bold = tFontSettingsTemp.bFontBold
    Control.Font.Italic = tFontSettingsTemp.bFontItalic
    
    Case Else
    'Do nothing
    
  End Select
  
  'Special cases, these settings do override everything else
  If Control Is frmSMSBlaster.cmdSend Then
    Control.Font.Bold = True
  End If
  
  If Control Is frmSMSBlaster.txtUnicode Then
    Control.Font.Size = Int(tFontSettingsTemp.rFontSize * 1.5)
  End If
  
Next Control

End Sub
Function ControlIsLoaded(ctlInput As Control) As Boolean
Dim sTemp As String
On Error GoTo ControlDoesntExist

sTemp = ctlInput.Tag

ControlIsLoaded = True

Exit Function

ControlDoesntExist:
ControlIsLoaded = False
End Function

Function GetNameFromPhoneBook(sPhoneNumber As String) As String
On Error Resume Next

frmSMSBlaster.dtaPhonebook.Recordset.FindFirst LoadLanguageSpecificString(gnLanguage, 197) & " = '" & sPhoneNumber & "'"

If frmSMSBlaster.dtaPhonebook.Recordset.NoMatch Then
  GetNameFromPhoneBook = ""
Else
  GetNameFromPhoneBook = frmSMSBlaster.dtaPhonebook.Recordset(LoadLanguageSpecificString(gnLanguage, 196)) & ""
End If

frmSMSBlaster.dtaPhonebook.Recordset.MoveFirst
End Function


Function GetSettingFromDatabase(sSettingType As String) As Variant
Dim sVersionSpecific1 As String
Dim sVersionSpecific2 As String
Dim sVersionSpecific3 As String

VersionSpecificAction 17, , , sVersionSpecific1
VersionSpecificAction 18, , , sVersionSpecific2
VersionSpecificAction 19, , , sVersionSpecific3

frmSMSBlaster.dtaSettings.Recordset.FindFirst "SettingType = '" & UCase(sSettingType) & "'"

If frmSMSBlaster.dtaSettings.Recordset.NoMatch Then   'Settingrecord not found in database, applying default value
  Select Case UCase(sSettingType)
  Case "USERKEY", "PASSWORD", "ORIGINATOR", "FONTNAME", "OTANOTIFICATIONSETTINGSMOBILENUMBER"
  GetSettingFromDatabase = ""
  
  Case "JOBREMARKSFIELD01", "JOBREMARKSFIELD02", "JOBREMARKSFIELD03", "JOBREMARKSFIELD04", "JOBREMARKSFIELD05", "JOBREMARKSFIELD06", "JOBREMARKSMEMO"
  GetSettingFromDatabase = "DEFAULT"
  
  Case "PHONEBOOKVARIABLEFIELD01", "PHONEBOOKVARIABLEFIELD02", "PHONEBOOKVARIABLEFIELD03"
  GetSettingFromDatabase = "DEFAULT"
  
  Case "JOBREMARKSDEFAULT01", "JOBREMARKSDEFAULT02", "JOBREMARKSDEFAULT03", "JOBREMARKSDEFAULT04", "JOBREMARKSDEFAULT05", "JOBREMARKSDEFAULT06"
  GetSettingFromDatabase = ""
  
  Case "FONTBOLD", "FONTITALIC", "FONTSTRIKETHRU", "FONTUNDERLINE", "SPECIFICFONTUSED", "TEXTSMSENABLED", _
       "OPERATORLOGOENABLED", "GROUPLOGOENABLED", "RINGTONEENABLED", "PICTUREMESSAGEENABLED", "VCARDENABLED", "UNICODEENABLED", _
       "WAPPUSHSMSENABLED", "BINARYDATAENABLED", sVersionSpecific1, sVersionSpecific2, sVersionSpecific3, "SAVEMESSAGESINSENDJOURNAL", _
       "OTANOTIFICATIONSETTINGSUSESERVICE", "OTANOTIFICATIONSETTINGSEVENTBUFFERED", "OTANOTIFICATIONSETTINGSEVENTDELIVERED", _
       "OTANOTIFICATIONSETTINGSEVENTNOTDELIVERED", "OTANOTIFICATIONSETTINGSREPLACE"
  GetSettingFromDatabase = False
  
  Case "FONTSIZE", "LANGUAGE"
  GetSettingFromDatabase = 0
  
  Case "COLWIDTHJOBS00", "COLWIDTHJOBS01", "COLWIDTHJOBS02", "COLWIDTHJOBS03", "COLWIDTHJOBS04", "COLWIDTHJOBS05", _
       "COLWIDTHJOBS06", "COLWIDTHJOBS07", "COLWIDTHJOBS08", "COLWIDTHJOBS09", "COLWIDTHJOBS10", "COLWIDTHJOBS11", _
       "COLWIDTHJOBS12", "COLWIDTHJOBS13", "COLWIDTHJOBS14", "COLWIDTHJOBS15"
  GetSettingFromDatabase = -1
  
  Case "COLWIDTHSENDLOG00", "COLWIDTHSENDLOG01", "COLWIDTHSENDLOG02", "COLWIDTHSENDLOG03", "COLWIDTHSENDLOG04", _
       "COLWIDTHSENDLOG05", "COLWIDTHSENDLOG06", "COLWIDTHSENDLOG07", "COLWIDTHSENDLOG08", "COLWIDTHSENDLOG09", _
       "COLWIDTHSENDLOG10", "COLWIDTHSENDLOG11", "COLWIDTHSENDLOG12", "COLWIDTHSENDLOG13", "COLWIDTHSENDLOG14", _
       "COLWIDTHSENDLOG15"
  GetSettingFromDatabase = -1
  
  Case "SENDLOGFIELDENABLED01", "SENDLOGFIELDENABLED02", "SENDLOGFIELDENABLED03", "SENDLOGFIELDENABLED04", _
       "SENDLOGFIELDENABLED05", "SENDLOGFIELDENABLED06", "SENDLOGFIELDENABLED07", "SENDLOGFIELDENABLED08", _
       "SENDLOGFIELDENABLED09", "SENDLOGFIELDENABLED10", "SENDLOGFIELDENABLED11", "SENDLOGFIELDENABLED12", _
       "SENDLOGFIELDENABLED13", "SENDLOGFIELDENABLED14", "SENDLOGFIELDENABLED15", "SENDLOGFIELDENABLED16"
  GetSettingFromDatabase = True
  
  Case "JOBLOGFIELDENABLED01", "JOBLOGFIELDENABLED02", "JOBLOGFIELDENABLED03", "JOBLOGFIELDENABLED04", _
       "JOBLOGFIELDENABLED05", "JOBLOGFIELDENABLED06", "JOBLOGFIELDENABLED07", "JOBLOGFIELDENABLED08", _
       "JOBLOGFIELDENABLED09", "JOBLOGFIELDENABLED10", "JOBLOGFIELDENABLED11", "JOBLOGFIELDENABLED12", _
       "JOBLOGFIELDENABLED13", "JOBLOGFIELDENABLED14", "JOBLOGFIELDENABLED15", "JOBLOGFIELDENABLED16"
  GetSettingFromDatabase = True
    
  Case "SINGLESMSUSEUSERDEFINEDLIFETIME", "PERIODICSMSUSERDEFINEDLIFETIME"
  GetSettingFromDatabase = False
  
  Case "SINGLESMSUSEUDSETTINGSONLYFORSPECIFICSMSTYPES", "PERIODICSMSUSEUDSETTINGSONLYFORSPECIFICSMSTYPES"
  GetSettingFromDatabase = True
    
  Case "SINGLESMSVALIDITYPERIODMODE"
  GetSettingFromDatabase = ValidityPeriodMode.UseSpecificSettingsAsLifeTime

  Case "PERIODICSMSVALIDITYPERIODMODE"
  GetSettingFromDatabase = ValidityPeriodMode.UseWaitingTimeAsLifeTime
  
  Case "SINGLESMSSPECIFICSETTINGLIFETIME", "PERIODICSMSSPECIFICSETTINGLIFETIME"
  GetSettingFromDatabase = 3
  
  Case "SINGLESMSSPECIFICSETTINGLIFETIMEUNIT", "PERIODICSMSSPECIFICSETTINGLIFETIMEUNIT"
  GetSettingFromDatabase = 0

  Case Else
  GetSettingFromDatabase = 0
  
  End Select

Else  'Everything ok, Settingrecord found in database
  
  Select Case UCase(sSettingType)
  Case "USERKEY", "PASSWORD", "ORIGINATOR", "FONTNAME", "OTANOTIFICATIONSETTINGSMOBILENUMBER"
  GetSettingFromDatabase = frmSMSBlaster.dtaSettings.Recordset("SettingValue") & ""
  
  Case "JOBREMARKSFIELD01", "JOBREMARKSFIELD02", "JOBREMARKSFIELD03", "JOBREMARKSFIELD04", "JOBREMARKSFIELD05", "JOBREMARKSFIELD06", "JOBREMARKSMEMO"
  GetSettingFromDatabase = frmSMSBlaster.dtaSettings.Recordset("SettingValue") & ""
  
  Case "PHONEBOOKVARIABLEFIELD01", "PHONEBOOKVARIABLEFIELD02", "PHONEBOOKVARIABLEFIELD03"
  GetSettingFromDatabase = frmSMSBlaster.dtaSettings.Recordset("SettingValue") & ""
  
  Case "JOBREMARKSDEFAULT01", "JOBREMARKSDEFAULT02", "JOBREMARKSDEFAULT03", "JOBREMARKSDEFAULT04", "JOBREMARKSDEFAULT05", "JOBREMARKSDEFAULT06"
  GetSettingFromDatabase = frmSMSBlaster.dtaSettings.Recordset("SettingValue") & ""
  
  Case "FONTBOLD", "FONTITALIC", "FONTSTRIKETHRU", "FONTUNDERLINE", "SPECIFICFONTUSED", "TEXTSMSENABLED", _
       "OPERATORLOGOENABLED", "GROUPLOGOENABLED", "RINGTONEENABLED", "PICTUREMESSAGEENABLED", "VCARDENABLED", "UNICODEENABLED", _
       "WAPPUSHSMSENABLED", "BINARYDATAENABLED", sVersionSpecific1, sVersionSpecific2, sVersionSpecific3, "SAVEMESSAGESINSENDJOURNAL", _
       "OTANOTIFICATIONSETTINGSUSESERVICE", "OTANOTIFICATIONSETTINGSEVENTBUFFERED", "OTANOTIFICATIONSETTINGSEVENTDELIVERED", _
       "OTANOTIFICATIONSETTINGSEVENTNOTDELIVERED", "OTANOTIFICATIONSETTINGSREPLACE"
  If frmSMSBlaster.dtaSettings.Recordset("SettingValue") & "" = "TRUE" Then
    GetSettingFromDatabase = True
  Else
    GetSettingFromDatabase = False
  End If
  
  Case "FONTSIZE", "LANGUAGE"
  GetSettingFromDatabase = Val(frmSMSBlaster.dtaSettings.Recordset("SettingValue") & "")
  
  Case "COLWIDTHJOBS00", "COLWIDTHJOBS01", "COLWIDTHJOBS02", "COLWIDTHJOBS03", "COLWIDTHJOBS04", "COLWIDTHJOBS05", _
       "COLWIDTHJOBS06", "COLWIDTHJOBS07", "COLWIDTHJOBS08", "COLWIDTHJOBS09", "COLWIDTHJOBS10", "COLWIDTHJOBS11", _
       "COLWIDTHJOBS12", "COLWIDTHJOBS13", "COLWIDTHJOBS14", "COLWIDTHJOBS15"
  GetSettingFromDatabase = Val(frmSMSBlaster.dtaSettings.Recordset("SettingValue") & "")
  
  Case "COLWIDTHSENDLOG00", "COLWIDTHSENDLOG01", "COLWIDTHSENDLOG02", "COLWIDTHSENDLOG03", "COLWIDTHSENDLOG04", _
       "COLWIDTHSENDLOG05", "COLWIDTHSENDLOG06", "COLWIDTHSENDLOG07", "COLWIDTHSENDLOG08", "COLWIDTHSENDLOG09", _
       "COLWIDTHSENDLOG10", "COLWIDTHSENDLOG11", "COLWIDTHSENDLOG12", "COLWIDTHSENDLOG13", "COLWIDTHSENDLOG14", _
       "COLWIDTHSENDLOG15"
  GetSettingFromDatabase = Val(frmSMSBlaster.dtaSettings.Recordset("SettingValue") & "")
  
  Case "SENDLOGFIELDENABLED01", "SENDLOGFIELDENABLED02", "SENDLOGFIELDENABLED03", "SENDLOGFIELDENABLED04", _
       "SENDLOGFIELDENABLED05", "SENDLOGFIELDENABLED06", "SENDLOGFIELDENABLED07", "SENDLOGFIELDENABLED08", _
       "SENDLOGFIELDENABLED09", "SENDLOGFIELDENABLED10", "SENDLOGFIELDENABLED11", "SENDLOGFIELDENABLED12", _
       "SENDLOGFIELDENABLED13", "SENDLOGFIELDENABLED14", "SENDLOGFIELDENABLED15", "SENDLOGFIELDENABLED16"
  If frmSMSBlaster.dtaSettings.Recordset("SettingValue") & "" = "TRUE" Then
    GetSettingFromDatabase = True
  Else
    GetSettingFromDatabase = False
  End If
  
  Case "JOBLOGFIELDENABLED01", "JOBLOGFIELDENABLED02", "JOBLOGFIELDENABLED03", "JOBLOGFIELDENABLED04", _
       "JOBLOGFIELDENABLED05", "JOBLOGFIELDENABLED06", "JOBLOGFIELDENABLED07", "JOBLOGFIELDENABLED08", _
       "JOBLOGFIELDENABLED09", "JOBLOGFIELDENABLED10", "JOBLOGFIELDENABLED11", "JOBLOGFIELDENABLED12", _
       "JOBLOGFIELDENABLED13", "JOBLOGFIELDENABLED14", "JOBLOGFIELDENABLED15", "JOBLOGFIELDENABLED16"
  If frmSMSBlaster.dtaSettings.Recordset("SettingValue") & "" = "TRUE" Then
    GetSettingFromDatabase = True
  Else
    GetSettingFromDatabase = False
  End If
  
  Case "SINGLESMSUSEUSERDEFINEDLIFETIME", "SINGLESMSUSEUDSETTINGSONLYFORSPECIFICSMSTYPES", _
       "PERIODICSMSUSEUSERDEFINEDLIFETIME", "PERIODICSMSUSEUDSETTINGSONLYFORSPECIFICSMSTYPES"
  If frmSMSBlaster.dtaSettings.Recordset("SettingValue") & "" = "TRUE" Then
    GetSettingFromDatabase = True
  Else
    GetSettingFromDatabase = False
  End If
  
  Case "SINGLESMSVALIDITYPERIODMODE", "SINGLESMSSPECIFICSETTINGLIFETIME", "SINGLESMSSPECIFICSETTINGLIFETIMEUNIT", _
       "PERIODICSMSVALIDITYPERIODMODE", "PERIODICSMSSPECIFICSETTINGLIFETIME", "PERIODICSMSSPECIFICSETTINGLIFETIMEUNIT"
  GetSettingFromDatabase = Val(frmSMSBlaster.dtaSettings.Recordset("SettingValue") & "")

  Case Else
  GetSettingFromDatabase = 0
  
  End Select
  
End If

End Function

Sub InitApp()
Dim sSQL As String
Dim nDefaultTimeZone As Integer

VersionSpecificAction 2
VersionSpecificAction 3

VersionSpecificAction 1, 1
VersionSpecificAction 42
VersionSpecificAction 59

'Init Deferred Delivery Time
gtDeferredDeliveryTimeSettings.bUseDeferredDeliveryTime = False
VersionSpecificAction 36, nDefaultTimeZone
gtDeferredDeliveryTimeSettings.nTimeZone = nDefaultTimeZone
gtDeferredDeliveryTimeSettings.bSingleSMS = True
gtDeferredDeliveryTimeSettings.bPeriodicSMS = False
gtDeferredDeliveryTimeSettings.sDeliveryDate = Now()
gtDeferredDeliveryTimeSettings.sStartingDate = Now()
gtDeferredDeliveryTimeSettings.sNumberOfMessages = "10"
gtDeferredDeliveryTimeSettings.sWaitingTime = "1"
gtDeferredDeliveryTimeSettings.nWaitingPeriod = 3

'Init Filtersettings Sendjournal
gtSendLogFilterSettings.bDeliveryStatusFilterUsed = False
gtSendLogFilterSettings.bReasonCodeFilterUsed = False
gtSendLogFilterSettings.bRecipientNameFilterUsed = False
gtSendLogFilterSettings.bRecipientFilterUsed = False
gtSendLogFilterSettings.bJobIDFilterUsed = False
gtSendLogFilterSettings.lJobId = 0

'Simply take any desired control to save default value
gtFontSettingsDefault.sFontName = frmSMSBlaster.txtUserkey.Font
gtFontSettingsDefault.rFontSize = frmSMSBlaster.txtUserkey.FontSize
gtFontSettingsDefault.bFontBold = frmSMSBlaster.txtUserkey.FontBold
gtFontSettingsDefault.bFontItalic = frmSMSBlaster.txtUserkey.FontItalic

'DatabaseSettings General Settings
frmSMSBlaster.dtaSettings.DatabaseName = gsPathAndDatabaseName
frmSMSBlaster.dtaSettings.RecordSource = "select * from Settings"
frmSMSBlaster.dtaSettings.Refresh

RestoreGeneralSettings

RestoreLogSettings


Call frmSMSBlaster.txtSMS_Change
Call frmSMSBlaster.txtUnicode_Change

'Sendlog
Set gdbMain = OpenDatabase(gsPathAndDatabaseName)
Set grsSendlog = gdbMain.OpenRecordset("select * from SendJournal")

'DatabaseSettings Phonebook
gnPhoneBookSortOrder = 1
frmSMSBlaster.dtaPhonebook.DatabaseName = gsPathAndDatabaseName
frmSMSBlaster.dtaPhonebook.RecordSource = PhonebookSQLStatement()
frmSMSBlaster.dtaPhonebook.Refresh

frmSMSBlaster.grdPhonebook.Refresh

'DatabaseSettings Available Countrys
frmSMSBlaster.dtaCountrys.DatabaseName = gsPathAndDatabaseName
frmSMSBlaster.dtaCountrys.RecordSource = "select Country from Networks group by Country order by Country"
frmSMSBlaster.dtaCountrys.Refresh

frmSMSBlaster.dtaCountrys.Recordset.MoveFirst
Do While Not frmSMSBlaster.dtaCountrys.Recordset.EOF
  frmSMSBlaster.lstCountrys.AddItem frmSMSBlaster.dtaCountrys.Recordset("Country")
  frmSMSBlaster.dtaCountrys.Recordset.MoveNext
Loop

'DatabaseSettings Available Networks
frmSMSBlaster.dtaNetworks.DatabaseName = gsPathAndDatabaseName
frmSMSBlaster.dtaNetworks.RecordSource = "select * from Networks order by Country, MCC, MNC"
frmSMSBlaster.dtaNetworks.Refresh

'DatabaseSettings Templates
frmSMSBlaster.dtaTemplates.DatabaseName = gsPathAndDatabaseName
frmSMSBlaster.dtaTemplates.RecordSource = "select * from Templates order by ID"
frmSMSBlaster.dtaTemplates.Refresh
frmSMSBlaster.grdTemplates.ColWidth(0) = 0
frmSMSBlaster.grdTemplates.ColWidth(1) = frmSMSBlaster.grdTemplates.Width / 1.1

'Phonebook
frmSMSBlaster.grdPhonebook.ColWidth(0) = 0
frmSMSBlaster.grdPhonebook.ColWidth(1) = frmSMSBlaster.grdPhonebook.Width / 4
frmSMSBlaster.grdPhonebook.ColWidth(2) = frmSMSBlaster.grdPhonebook.Width / 4
frmSMSBlaster.grdPhonebook.ColWidth(3) = frmSMSBlaster.grdPhonebook.Width / 7
frmSMSBlaster.grdPhonebook.ColWidth(4) = frmSMSBlaster.grdPhonebook.Width / 7
frmSMSBlaster.grdPhonebook.ColWidth(5) = frmSMSBlaster.grdPhonebook.Width / 7

frmSMSBlaster.grdRecipients.ColWidth(0) = frmSMSBlaster.grdRecipients.Width / 2.3
frmSMSBlaster.grdRecipients.ColWidth(1) = frmSMSBlaster.grdRecipients.Width / 2.3
frmSMSBlaster.grdRecipients.ColWidth(2) = 0
frmSMSBlaster.grdRecipients.ColWidth(3) = 0
frmSMSBlaster.grdRecipients.ColWidth(4) = 0
frmSMSBlaster.grdRecipients.ColAlignment(0) = flexAlignLeftCenter
frmSMSBlaster.grdRecipients.ColAlignment(1) = flexAlignLeftCenter

frmSMSBlaster.dtaTemplates.DatabaseName = gsPathAndDatabaseName
frmSMSBlaster.dtaTemplates.RecordSource = "select * from Templates order by ID"
frmSMSBlaster.dtaTemplates.Refresh

Call frmSMSBlaster.grdPhonebook_Click
LoadSavedRandomLogosOnScreen

AdjustFontControls frmSMSBlaster

frmSMSBlaster.AdjustLanguageSettings gnLanguage
RestoreJobInfoSettings
End Sub
Function LoadLanguageSpecificString(nLanguage As Integer, nString As Integer) As String
On Error GoTo ErrorTrap
Dim nLookup As Integer

nLookup = nLanguage * 1000 + nString
LoadLanguageSpecificString = LoadResString(nLookup)

Exit Function
ErrorTrap:
'No Ressource found
LoadLanguageSpecificString = ""
Exit Function

End Function

Function ParseReceivedLogoControlDataOld(sInput As String, bSuccess As Boolean) As Long
Dim nPositionContentLenghtBegin As Integer
Dim nPositionContentLenghtEnd As Integer
Dim sContentLenghtToken As String
Dim nContentLenght As Integer
Dim sContent As String
Dim sTemp As String
Dim sTempArray() As String
Dim sRelevantItems() As String

sTemp = UCase(sInput)

If InStr(1, sTemp, "OBJECT NOT FOUND") >= 1 Then
  bSuccess = False
  Exit Function
End If

nPositionContentLenghtBegin = InStr(1, sTemp, UCase("Content-Length"))
nPositionContentLenghtEnd = InStr(nPositionContentLenghtBegin, sTemp, vbCrLf & vbCrLf)

sContentLenghtToken = Mid(sInput, nPositionContentLenghtBegin, (nPositionContentLenghtEnd - nPositionContentLenghtBegin))
sTempArray() = Split(sContentLenghtToken, ":")
nContentLenght = Val(sTempArray(1))

sContent = Mid(sInput, nPositionContentLenghtEnd + Len(vbCrLf & vbCrLf), nContentLenght)
If Left(sContent, 5) = "Logos" Then
  sRelevantItems() = Split(sContent, ":")
  ParseReceivedLogoControlDataOld = Val(sRelevantItems(1))
  bSuccess = True
Else
  bSuccess = False
End If

Exit Function
ErrorTrap:
Exit Function
End Function

Function ParseReceivedLogoControlData(sInput As String, bSuccess As Boolean) As Long
Dim nPositionContentLenghtBegin As Integer
Dim nPositionContentLenghtEnd As Integer
Dim sContentLenghtToken As String
Dim nContentLenght As Integer
Dim sContent As String
Dim sTemp As String
Dim sTempArray() As String
Dim sRelevantItems() As String

sTemp = UCase(sInput)

If InStr(1, sTemp, "OBJECT NOT FOUND") >= 1 Then
  bSuccess = False
  Exit Function
End If

If UCase(Left(sTemp, 5)) = UCase("Logos") Then
  sRelevantItems() = Split(sTemp, ":")
  ParseReceivedLogoControlData = Val(sRelevantItems(1))
  bSuccess = True
Else
  bSuccess = False
End If

Exit Function
ErrorTrap:
Exit Function
End Function


Function ParseReceivedPictureData(sInput As String, bSuccess As Boolean) As String
Dim nPositionContentLenghtBegin As Integer
Dim nPositionContentLenghtEnd As Integer
Dim sContentLenghtToken As String
Dim nContentLenght As Integer
Dim sContent As String
Dim sTemp As String
Dim sTempArray() As String

sTemp = UCase(sInput)

If InStr(1, sTemp, "OBJECT NOT FOUND") >= 1 Then
  bSuccess = False
  Exit Function
End If

nPositionContentLenghtBegin = InStr(1, sTemp, UCase("Content-Length"))
nPositionContentLenghtEnd = InStr(nPositionContentLenghtBegin, sTemp, vbCrLf & vbCrLf)

sContentLenghtToken = Mid(sInput, nPositionContentLenghtBegin, (nPositionContentLenghtEnd - nPositionContentLenghtBegin))
sTempArray() = Split(sContentLenghtToken, ":")
nContentLenght = Val(sTempArray(1))

sContent = Mid(sInput, nPositionContentLenghtEnd + Len(vbCrLf & vbCrLf), nContentLenght)
If Left(sContent, 2) = "BM" Then
  ParseReceivedPictureData = sContent
  bSuccess = True
Else
  bSuccess = False
End If

Exit Function
ErrorTrap:
Exit Function
End Function


Sub ProcessRandomLogoDisplayUpdate(nIndex As Integer, sPicture As String)
Dim sFilename As String
Dim nFile As Integer

sFilename = App.Path & "\" & Right("0000" & Trim(Str$(nIndex)), 4) & ".bmp"

On Error GoTo ErrorTrap

nFile = FreeFile

Open sFilename For Binary As nFile
Put nFile, , sPicture

Close nFile

Exit Sub

ErrorTrap:
Exit Sub

End Sub

Sub PutSettingIntoDataBase(sSettingType As String, vSettingValue As Variant)
Dim sVersionSpecific1 As String
Dim sVersionSpecific2 As String
Dim sVersionSpecific3 As String

VersionSpecificAction 17, , , sVersionSpecific1
VersionSpecificAction 18, , , sVersionSpecific2
VersionSpecificAction 19, , , sVersionSpecific3

frmSMSBlaster.dtaSettings.Recordset.FindFirst "SettingType = '" & UCase(sSettingType) & "'"

If frmSMSBlaster.dtaSettings.Recordset.NoMatch Then
  frmSMSBlaster.dtaSettings.Recordset.AddNew
Else
  frmSMSBlaster.dtaSettings.Recordset.Edit
End If

frmSMSBlaster.dtaSettings.Recordset("SettingType") = sSettingType

Select Case UCase(sSettingType)
  Case "USERKEY", "PASSWORD", "ORIGINATOR", "FONTNAME", "OTANOTIFICATIONSETTINGSMOBILENUMBER"
  frmSMSBlaster.dtaSettings.Recordset("SettingValue") = vSettingValue & ""
  
  Case "JOBREMARKSFIELD01", "JOBREMARKSFIELD02", "JOBREMARKSFIELD03", "JOBREMARKSFIELD04", "JOBREMARKSFIELD05", "JOBREMARKSFIELD06", "JOBREMARKSMEMO"
  frmSMSBlaster.dtaSettings.Recordset("SettingValue") = vSettingValue & ""
  
  Case "PHONEBOOKVARIABLEFIELD01", "PHONEBOOKVARIABLEFIELD02", "PHONEBOOKVARIABLEFIELD03"
  frmSMSBlaster.dtaSettings.Recordset("SettingValue") = vSettingValue & ""
  
  Case "JOBREMARKSDEFAULT01", "JOBREMARKSDEFAULT02", "JOBREMARKSDEFAULT03", "JOBREMARKSDEFAULT04", "JOBREMARKSDEFAULT05", "JOBREMARKSDEFAULT06"
  frmSMSBlaster.dtaSettings.Recordset("SettingValue") = vSettingValue & ""
   
  Case "FONTBOLD", "FONTITALIC", "FONTSTRIKETHRU", "FONTUNDERLINE", "SPECIFICFONTUSED", "TEXTSMSENABLED", _
       "OPERATORLOGOENABLED", "GROUPLOGOENABLED", "RINGTONEENABLED", "PICTUREMESSAGEENABLED", "VCARDENABLED", "WAPPUSHSMSENABLED", _
       "BINARYDATAENABLED", "UNICODEENABLED", sVersionSpecific1, sVersionSpecific2, sVersionSpecific3, "SAVEMESSAGESINSENDJOURNAL", _
       "OTANOTIFICATIONSETTINGSUSESERVICE", "OTANOTIFICATIONSETTINGSEVENTBUFFERED", "OTANOTIFICATIONSETTINGSEVENTDELIVERED", _
       "OTANOTIFICATIONSETTINGSEVENTNOTDELIVERED", "OTANOTIFICATIONSETTINGSREPLACE"
  If vSettingValue = True Then
    frmSMSBlaster.dtaSettings.Recordset("SettingValue") = "TRUE"
  Else
    frmSMSBlaster.dtaSettings.Recordset("SettingValue") = "FALSE"
  End If
  
  Case "FONTSIZE", "LANGUAGE"
  frmSMSBlaster.dtaSettings.Recordset("SettingValue") = Str$(vSettingValue)
  
  Case "COLWIDTHJOBS00", "COLWIDTHJOBS01", "COLWIDTHJOBS02", "COLWIDTHJOBS03", "COLWIDTHJOBS04", "COLWIDTHJOBS05", _
       "COLWIDTHJOBS06", "COLWIDTHJOBS07", "COLWIDTHJOBS08", "COLWIDTHJOBS09", "COLWIDTHJOBS10", "COLWIDTHJOBS11", _
       "COLWIDTHJOBS12", "COLWIDTHJOBS13", "COLWIDTHJOBS14", "COLWIDTHJOBS15", "COLWIDTHJOBS15"
  frmSMSBlaster.dtaSettings.Recordset("SettingValue") = Str$(vSettingValue)
  
  Case "COLWIDTHSENDLOG00", "COLWIDTHSENDLOG01", "COLWIDTHSENDLOG02", "COLWIDTHSENDLOG03", "COLWIDTHSENDLOG04", _
       "COLWIDTHSENDLOG05", "COLWIDTHSENDLOG06", "COLWIDTHSENDLOG07", "COLWIDTHSENDLOG08", "COLWIDTHSENDLOG09", _
       "COLWIDTHSENDLOG10", "COLWIDTHSENDLOG11", "COLWIDTHSENDLOG12", "COLWIDTHSENDLOG13", "COLWIDTHSENDLOG14", _
       "COLWIDTHSENDLOG15"
  frmSMSBlaster.dtaSettings.Recordset("SettingValue") = Str$(vSettingValue)
  
  Case "SENDLOGFIELDENABLED01", "SENDLOGFIELDENABLED02", "SENDLOGFIELDENABLED03", "SENDLOGFIELDENABLED04", _
       "SENDLOGFIELDENABLED05", "SENDLOGFIELDENABLED06", "SENDLOGFIELDENABLED07", "SENDLOGFIELDENABLED08", _
       "SENDLOGFIELDENABLED09", "SENDLOGFIELDENABLED10", "SENDLOGFIELDENABLED11", "SENDLOGFIELDENABLED12", _
       "SENDLOGFIELDENABLED13", "SENDLOGFIELDENABLED14", "SENDLOGFIELDENABLED15", "SENDLOGFIELDENABLED16"
  If vSettingValue = True Then
    frmSMSBlaster.dtaSettings.Recordset("SettingValue") = "TRUE"
  Else
    frmSMSBlaster.dtaSettings.Recordset("SettingValue") = "FALSE"
  End If
  
  Case "JOBLOGFIELDENABLED01", "JOBLOGFIELDENABLED02", "JOBLOGFIELDENABLED03", "JOBLOGFIELDENABLED04", _
       "JOBLOGFIELDENABLED05", "JOBLOGFIELDENABLED06", "JOBLOGFIELDENABLED07", "JOBLOGFIELDENABLED08", _
       "JOBLOGFIELDENABLED09", "JOBLOGFIELDENABLED10", "JOBLOGFIELDENABLED11", "JOBLOGFIELDENABLED12", _
       "JOBLOGFIELDENABLED13", "JOBLOGFIELDENABLED14", "JOBLOGFIELDENABLED15", "JOBLOGFIELDENABLED16"
  If vSettingValue = True Then
    frmSMSBlaster.dtaSettings.Recordset("SettingValue") = "TRUE"
  Else
    frmSMSBlaster.dtaSettings.Recordset("SettingValue") = "FALSE"
  End If
  
  Case "SINGLESMSUSEUSERDEFINEDLIFETIME", "SINGLESMSUSEUDSETTINGSONLYFORSPECIFICSMSTYPES", _
       "PERIODICSMSUSEUSERDEFINEDLIFETIME", "PERIODICSMSUSEUDSETTINGSONLYFORSPECIFICSMSTYPES"
  If vSettingValue = True Then
    frmSMSBlaster.dtaSettings.Recordset("SettingValue") = "TRUE"
  Else
    frmSMSBlaster.dtaSettings.Recordset("SettingValue") = "FALSE"
  End If
  
  Case "SINGLESMSVALIDITYPERIODMODE", "SINGLESMSSPECIFICSETTINGLIFETIME", "SINGLESMSSPECIFICSETTINGLIFETIMEUNIT", _
       "PERIODICSMSVALIDITYPERIODMODE", "PERIODICSMSSPECIFICSETTINGLIFETIME", "PERIODICSMSSPECIFICSETTINGLIFETIMEUNIT"
  frmSMSBlaster.dtaSettings.Recordset("SettingValue") = Str$(vSettingValue)
  
  Case Else
  'Do nothing
    
End Select
frmSMSBlaster.dtaSettings.Recordset.Update



End Sub

Sub ReadInRecipientsFile(sInputFile As String)
Dim nInputFile As Integer
Dim sLine As String
Dim nCounter As Integer

nInputFile = FreeFile

Open sInputFile For Input As nInputFile

If FileLen(sInputFile) = 0 Then
  Exit Sub
End If

Do While Not EOF(nInputFile)
  Line Input #nInputFile, sLine
  frmSMSBlaster.grdRecipients.AddItem LoadLanguageSpecificString(gnLanguage, 198) & Chr$(9) & sLine
  nCounter = nCounter + 1
Loop

Close nInputFile

MsgBox Str$(nCounter) & " " & LoadLanguageSpecificString(gnLanguage, 199), vbInformation, gsApplicationName
End Sub


Sub RefreshPreviewGrid(sInputFile As String)
Dim nInputFile As Integer
Dim sLine As String
Dim lCounter As Long
Dim sSeparator As String
Dim nFormat As Integer
Dim sLineParts() As String
Dim nMaxLineParts As Integer
Dim nMaxVisibleCols As Integer
Dim i As Integer

On Error GoTo ErrorTrap

Screen.MousePointer = vbHourglass

nInputFile = FreeFile

Open sInputFile For Input As nInputFile

If FileLen(sInputFile) = 0 Then
  Close nInputFile
  Exit Sub
End If

'The used Separator
Select Case True
  Case UCase(frmImport.cboSeparator.Text) = "<TAB>"
  sSeparator = vbTab
  
  Case UCase(frmImport.cboSeparator.Text) = "<SPACE>"
  sSeparator = " "
  
  Case Else
  sSeparator = Left(frmImport.cboSeparator.Text, 1)
  
End Select

frmImport.grdImport.Cols = 1
frmImport.grdImport.Rows = 1

Do While Not EOF(nInputFile)
  Line Input #nInputFile, sLine
  
  sLineParts = Split(sLine, sSeparator)
  
  If UBound(sLineParts) <> -1 Then
    lCounter = lCounter + 1
  End If
  
  If UBound(sLineParts) + 1 > nMaxLineParts Then
    nMaxLineParts = UBound(sLineParts) + 1
  End If
Loop
Close
If nMaxLineParts <= 5 Then
  nMaxVisibleCols = nMaxLineParts
Else
  nMaxVisibleCols = nMaxLineParts
End If

For i = 1 To frmImport.cboDatabaseField.UBound
  Unload frmImport.cboDatabaseField(i)
Next

frmImport.grdImport.Rows = 0
frmImport.grdImport.Cols = 0

frmImport.cboDatabaseField(0).Width = frmImport.grdImport.Width / nMaxVisibleCols * 0.9
frmImport.cboDatabaseField(0).Clear
frmImport.cboDatabaseField(0).AddItem LoadLanguageSpecificString(gnLanguage, 20)
frmImport.cboDatabaseField(0).AddItem LoadLanguageSpecificString(gnLanguage, 196)
frmImport.cboDatabaseField(0).AddItem LoadLanguageSpecificString(gnLanguage, 197)
frmImport.cboDatabaseField(0).AddItem gsPhonebookVariableField(gnLanguage, 1)
frmImport.cboDatabaseField(0).AddItem gsPhonebookVariableField(gnLanguage, 2)
frmImport.cboDatabaseField(0).AddItem gsPhonebookVariableField(gnLanguage, 3)
frmImport.cboDatabaseField(0).Visible = True
frmImport.cboDatabaseField(0).ListIndex = 0

For i = 1 To nMaxLineParts - 1
  Load frmImport.cboDatabaseField(i)
  frmImport.cboDatabaseField(i).Top = frmImport.cboDatabaseField(0).Top
  frmImport.cboDatabaseField(i).Left = frmImport.cboDatabaseField(0).Left + _
                                      (frmImport.grdImport.Width / nMaxVisibleCols * 0.95) * (i)
  frmImport.cboDatabaseField(i).Width = frmImport.grdImport.Width / nMaxVisibleCols * 0.9
  frmImport.cboDatabaseField(i).Visible = True
  frmImport.cboDatabaseField(i).AddItem LoadLanguageSpecificString(gnLanguage, 20)
  frmImport.cboDatabaseField(i).AddItem LoadLanguageSpecificString(gnLanguage, 196)
  frmImport.cboDatabaseField(i).AddItem LoadLanguageSpecificString(gnLanguage, 197)
  frmImport.cboDatabaseField(i).AddItem gsPhonebookVariableField(gnLanguage, 1)
  frmImport.cboDatabaseField(i).AddItem gsPhonebookVariableField(gnLanguage, 2)
  frmImport.cboDatabaseField(i).AddItem gsPhonebookVariableField(gnLanguage, 3)
  frmImport.cboDatabaseField(i).ListIndex = 0
Next
DoEvents
For i = 1 To frmImport.grdImport.Cols - 1
   frmImport.cboDatabaseField(i).Left = frmImport.grdImport.ColWidth(i) * (i) + frmImport.cboDatabaseField(0).Left + (i * 6)
Next

frmImport.grdImport.Cols = nMaxLineParts

For i = 0 To nMaxLineParts - 1
  frmImport.grdImport.ColWidth(i) = frmImport.grdImport.Width / nMaxVisibleCols * 0.95
  frmImport.grdImport.ColAlignment(i) = flexAlignLeftCenter
Next
frmImport.grdImport.Rows = lCounter
lCounter = 0

Open sInputFile For Input As nInputFile

Do While Not EOF(nInputFile)
  Line Input #nInputFile, sLine
  
  'Remove Separators used twice
  
  sLineParts = Split(sLine, sSeparator)
  
  Select Case UBound(sLineParts)
     
     Case -1
     'Do nothing
       
     Case Else
     For i = 0 To UBound(sLineParts)
       frmImport.grdImport.TextMatrix(lCounter, i) = sLineParts(i)
     Next
     lCounter = lCounter + 1
           
   End Select
  
Loop

frmImport.grdImport.Col = 0
frmImport.grdImport.Row = 0
frmImport.grdImport.ColSel = frmImport.grdImport.Cols - 1
frmImport.grdImport.RowSel = frmImport.grdImport.Rows - 1

frmImport.grdImport.CellForeColor = &H808080

frmImport.grdImport.ColSel = 0
frmImport.grdImport.RowSel = 0

Screen.MousePointer = vbDefault

RefreshImportCounter

frmImport.cmdRemoveFromImportList.Enabled = True
frmImport.cmdSelectAll.Enabled = True
frmImport.cmdSaveRecords(1).Enabled = True
frmImport.cmdSaveRecords(2).Enabled = True
frmImport.cmdRefreshWindow.Enabled = True


Exit Sub
ErrorTrap:

Select Case Err.Number
  Case 30006
  MsgBox LoadLanguageSpecificString(gnLanguage, 26), vbCritical, gsApplicationName
    
  Case Else
  'Do nothing
  
End Select

Close
Screen.MousePointer = vbDefault
End Sub
Sub RefreshDataImportWindow(sInputFile As String)
Dim nInputFile As Integer
Dim sLine As String
Dim lCounter As Long
Dim sSeparator As String
Dim nFormat As Integer
Dim sLineParts() As String

Screen.MousePointer = vbHourglass

nInputFile = FreeFile

Open sInputFile For Input As nInputFile

If FileLen(sInputFile) = 0 Then
  Exit Sub
End If


'The used Separator
Select Case True
  Case UCase(frmImport.cboSeparator.Text) = "<TAB>"
  sSeparator = vbTab
  
  Case UCase(frmImport.cboSeparator.Text) = "<SPACE>"
  sSeparator = " "
  
  Case Else
  sSeparator = Left(frmImport.cboSeparator.Text, 1)
  
End Select



Do While Not EOF(nInputFile)
  
  Line Input #nInputFile, sLine
  
  'Remove Separators used twice
  Do While InStr(1, sLine, sSeparator & sSeparator) > 0
    sLine = Replace(sLine, sSeparator & sSeparator, sSeparator)
  Loop
  
  Select Case nFormat
  
    Case 0 'Name <Separator> PhoneNumber
    sLineParts = Split(sLine, sSeparator)
    Select Case UBound(sLineParts)
      Case 1
      
      
      Case 0
      
      
      Case Else
      'Do nothing
      
    End Select
      
    Case 1 'PhoneNumber <Separator> Name
    sLineParts = Split(sLine, sSeparator)
    Select Case UBound(sLineParts)
      Case 1
      
      
      Case 0
      
      
      Case Else
      'Do nothing
      
    End Select
      
    Case 2 'Only Name
    sLine = Replace(sLine, vbTab, " ")
    
  
    Case 3 'Only Phonenumber
    sLine = Replace(sLine, vbTab, " ")
    
    
    Case Else
    'Unexecpted, do nothing, probably an application bug
  
  End Select
  
  lCounter = lCounter + 1
  
Loop

Close nInputFile
Screen.MousePointer = vbDefault
End Sub

Sub RestoreGeneralSettings()
Dim i As Integer
Dim k As Integer
Dim nIndexLastUsedControl As Integer
Dim nIndexFirstEnabledControl As Integer
Dim bEnabledControlFound As Boolean
Dim sTemp As String
Dim sJobRemarksField As String
ReDim boptSMSTypeCheck(0 To 11) As Boolean

frmSMSBlaster.txtUserkey.Text = GetSettingFromDatabase("Userkey")
frmSMSBlaster.txtPassword.Text = GetSettingFromDatabase("Password")
frmSMSBlaster.txtOriginator.Text = GetSettingFromDatabase("Originator")

gnLanguage = GetSettingFromDatabase("Language")

Select Case gnLanguage
  Case 1
  frmSMSBlaster.mnuLanguage(1).Checked = True
  frmSMSBlaster.mnuLanguage(2).Checked = False

  Case 2
  frmSMSBlaster.mnuLanguage(1).Checked = False
  frmSMSBlaster.mnuLanguage(2).Checked = True
    
  Case Else
    
End Select

gtFontSettingsCurrent.bSpecificFontUsed = GetSettingFromDatabase("SpecificFontUsed")
gtFontSettingsCurrent.sFontName = GetSettingFromDatabase("FontName")
gtFontSettingsCurrent.rFontSize = GetSettingFromDatabase("FontSize")
gtFontSettingsCurrent.bFontBold = GetSettingFromDatabase("FontBold")
gtFontSettingsCurrent.bFontItalic = GetSettingFromDatabase("FontItalic")

For i = frmSMSBlaster.optSMSType.LBound To frmSMSBlaster.optSMSType.UBound
  If frmSMSBlaster.optSMSType(i).Value = True Then
    nIndexLastUsedControl = i
    Exit For
  End If
Next
gtMenuControl.bTextSMSEnabled = GetSettingFromDatabase("TextSMSEnabled")
gtMenuControl.bOperatorLogoEnabled = GetSettingFromDatabase("OperatorLogoEnabled")
gtMenuControl.bGroupLogoEnabled = GetSettingFromDatabase("GroupLogoEnabled")
gtMenuControl.bRingtoneEnabled = GetSettingFromDatabase("RingtoneEnabled")
gtMenuControl.bPictureMessageEnabled = GetSettingFromDatabase("PictureMessageEnabled")
gtMenuControl.bVCardEnabled = GetSettingFromDatabase("VCardEnabled")
gtMenuControl.bUnicodeEnabled = GetSettingFromDatabase("UnicodeEnabled")
gtMenuControl.bWAPPushSMSEnabled = GetSettingFromDatabase("WAPPushSMSEnabled")
gtMenuControl.bBinaryDataEnabled = GetSettingFromDatabase("BinaryDataEnabled")

VersionSpecificAction 13

frmSMSBlaster.optSMSType(0).Enabled = gtMenuControl.bTextSMSEnabled
frmSMSBlaster.optSMSType(1).Enabled = gtMenuControl.bOperatorLogoEnabled
frmSMSBlaster.optSMSType(2).Enabled = gtMenuControl.bGroupLogoEnabled
frmSMSBlaster.optSMSType(3).Enabled = gtMenuControl.bRingtoneEnabled
frmSMSBlaster.optSMSType(4).Enabled = gtMenuControl.bPictureMessageEnabled
frmSMSBlaster.optSMSType(5).Enabled = gtMenuControl.bVCardEnabled
frmSMSBlaster.optSMSType(6).Enabled = gtMenuControl.bUnicodeEnabled
frmSMSBlaster.optSMSType(7).Enabled = gtMenuControl.bWAPPushSMSEnabled
frmSMSBlaster.optSMSType(8).Enabled = gtMenuControl.bBinaryDataEnabled

VersionSpecificAction 4

boptSMSTypeCheck(0) = gtMenuControl.bTextSMSEnabled
boptSMSTypeCheck(1) = gtMenuControl.bOperatorLogoEnabled
boptSMSTypeCheck(2) = gtMenuControl.bGroupLogoEnabled
boptSMSTypeCheck(3) = gtMenuControl.bRingtoneEnabled
boptSMSTypeCheck(4) = gtMenuControl.bPictureMessageEnabled
boptSMSTypeCheck(5) = gtMenuControl.bVCardEnabled
boptSMSTypeCheck(6) = gtMenuControl.bUnicodeEnabled
boptSMSTypeCheck(7) = gtMenuControl.bWAPPushSMSEnabled
boptSMSTypeCheck(8) = gtMenuControl.bBinaryDataEnabled

VersionSpecificAction 14, , , , boptSMSTypeCheck(9)
VersionSpecificAction 15, , , , boptSMSTypeCheck(10)
VersionSpecificAction 16, , , , boptSMSTypeCheck(11)

If boptSMSTypeCheck(nIndexLastUsedControl) = True Then
  'Do nothing, everything ok
  frmSMSBlaster.optSMSType(nIndexLastUsedControl).Value = True
Else
  'Search for available control
  For i = LBound(boptSMSTypeCheck) To UBound(boptSMSTypeCheck)
    If boptSMSTypeCheck(i) = True Then
      nIndexFirstEnabledControl = i
      bEnabledControlFound = True
      Exit For
    End If
  Next

  If bEnabledControlFound Then  'At least one available
    frmSMSBlaster.optSMSType(nIndexFirstEnabledControl).Value = True
    frmSMSBlaster.cmdSend.Enabled = True
  Else
    'No control found
    For i = frmSMSBlaster.optSMSType.LBound To frmSMSBlaster.optSMSType.UBound
      frmSMSBlaster.optSMSType(i).Value = False
    Next
    frmSMSBlaster.cmdSend.Caption = "Send"
    frmSMSBlaster.cmdSend.Enabled = False
  End If
End If

gbSaveMessagesInSendLog = GetSettingFromDatabase("SaveMessagesInSendJournal")

For i = 1 To 2  'Language
  For k = LBound(gsPhonebookVariableField, 2) To UBound(gsPhonebookVariableField, 2) 'Number of Variable Fields
    gsPhonebookVariableField(i, k) = GetPhonebookVariableFieldFromDatabase(i, k)
  Next
Next

gtValidityPeriodSettings.bSingleSMSUseUserDefinedLifeTime = GetSettingFromDatabase("SingleSMSUseUserDefinedLifetime")
gtValidityPeriodSettings.bSingleSMSUseUserDefinedSettingsOnlyForSpecificSMSTypes = GetSettingFromDatabase("SingleSMSUseUDSettingsOnlyForSpecificSMSTypes")
gtValidityPeriodSettings.nSingleSMSValidityPeriodMode = GetSettingFromDatabase("SingleSMSValidityPeriodMode")
gtValidityPeriodSettings.lSingleSMSSpecificSettingLifeTime = GetSettingFromDatabase("SingleSMSSpecificSettingLifeTime")
gtValidityPeriodSettings.nSingleSMSSpecificSettingLifeTimeUnit = GetSettingFromDatabase("SingleSMSSpecificSettingLifeTimeUnit")

gtValidityPeriodSettings.bPeriodicSMSUseUserDefinedLifeTime = GetSettingFromDatabase("PeriodicSMSUseUserDefinedLifeTime")
gtValidityPeriodSettings.bPeriodicSMSUseUserDefinedSettingsOnlyForSpecificSMSTypes = GetSettingFromDatabase("PeriodicSMSUseUDSettingsOnlyForSpecificSMSTypes")
gtValidityPeriodSettings.nPeriodicSMSValidityPeriodMode = GetSettingFromDatabase("PeriodicSMSValidityPeriodMode")
gtValidityPeriodSettings.lPeriodicSMSSpecificSettingLifeTime = GetSettingFromDatabase("PeriodicSMSSpecificSettingLifeTime")
gtValidityPeriodSettings.nPeriodicSMSSpecificSettingLifeTimeUnit = GetSettingFromDatabase("PeriodicSMSSpecificSettingLifeTimeUnit")
End Sub
Sub SaveOutgoingMessage(sRecipient As String, sRecipientNameFromGrid As String, sTransactionReferenceNumber As String, sMessage As String, sDeferredDeliveryTime As String, lJobId As Long)
grsSendlog.AddNew
  If sRecipientNameFromGrid = "" Then
    grsSendlog("sName") = GetNameFromPhoneBook(sRecipient)
  Else
    grsSendlog("sName") = sRecipientNameFromGrid
  End If
  grsSendlog("sRecipient") = sRecipient & ""
  grsSendlog("sTransactionReferenceNumber") = sTransactionReferenceNumber & ""
  grsSendlog("sMessage") = sMessage & ""

  If sDeferredDeliveryTime <> "" Then
    grsSendlog("dDeferredDeliveryTime") = CVDate(sDeferredDeliveryTime) & ""
  End If
  grsSendlog("sDeliveryStatus") = "???"
  grsSendlog("sDeliveryStatusText") = "???"
  grsSendlog("sReasonCode") = "???"
  grsSendlog("sReasonText") = "???"
  grsSendlog("sReasonCodeBuffered") = "???"
  grsSendlog("sReasonTextBuffered") = "???"
  grsSendlog("lJobID") = lJobId
grsSendlog.Update
End Sub

Function ConvertStringToDate(sDDMMYYYYHHmmss As String) As Date
Dim sWork As String
Dim dWork As Date

Dim nYear As Integer
Dim nMonth As Integer
Dim nDay As Integer
Dim nHour As Integer
Dim nMinute As Integer
Dim nSecond As Integer

sWork = sDDMMYYYYHHmmss

'Check Length
If Len(sWork) > 14 Then
  sWork = Left(sWork, 14)
End If

If Len(sWork) < 14 Then
  ConvertStringToDate = False
  Exit Function
End If

nDay = Val(Mid(sWork, 1, 2))
nMonth = Val(Mid(sWork, 3, 2))
nYear = Val(Mid(sWork, 5, 4))
nHour = Val(Mid(sWork, 9, 2))
nMinute = Val(Mid(sWork, 11, 2))
nSecond = Val(Mid(sWork, 13, 2))

dWork = DateSerial(nYear, nMonth, nDay)
dWork = DateAdd("h", nHour, dWork)
dWork = DateAdd("n", nMinute, dWork)
dWork = DateAdd("s", nSecond, dWork)

ConvertStringToDate = dWork
End Function


Function DeliveryStatusFromDeliveryStatusCode(sDeliveryStatus As String) As String
Select Case sDeliveryStatus

  Case "-1"
  DeliveryStatusFromDeliveryStatusCode = LoadLanguageSpecificString(gnLanguage, 203)

  Case "0"
  DeliveryStatusFromDeliveryStatusCode = LoadLanguageSpecificString(gnLanguage, 204)

  Case "1"
  DeliveryStatusFromDeliveryStatusCode = LoadLanguageSpecificString(gnLanguage, 205)

  Case "2"
  DeliveryStatusFromDeliveryStatusCode = LoadLanguageSpecificString(gnLanguage, 206)

  Case Else
  'Unexecpted, do nothing, probably an application bug

End Select
End Function


Function ReasonRemarkFromReasonCodeTill(sReasonCode As String, sDST As String) As String
Select Case sReasonCode

  Case ""
  ReasonRemarkFromReasonCodeTill = ""

  Case "000"
  ReasonRemarkFromReasonCodeTill = "Es wurde versucht, eine Mitteilung an eine Nummer zu schicken, die nicht oder nicht mehr existiert. Bitte berprfen Sie, ob Sie die Nummer richtig eingegeben haben."

  Case "001"
  ReasonRemarkFromReasonCodeTill = "-"

  Case "002"
  ReasonRemarkFromReasonCodeTill = "-"

  Case "003"
  ReasonRemarkFromReasonCodeTill = "-"

  Case "004"
  ReasonRemarkFromReasonCodeTill = "-"

  Case "005"
  ReasonRemarkFromReasonCodeTill = "-"

  Case "006"
  ReasonRemarkFromReasonCodeTill = "-"

  Case "007"
  ReasonRemarkFromReasonCodeTill = "-"

  Case "008"
  ReasonRemarkFromReasonCodeTill = "-"

  Case "009"
  ReasonRemarkFromReasonCodeTill = "-"

  Case "010"
  ReasonRemarkFromReasonCodeTill = "-"

  Case "100"
  ReasonRemarkFromReasonCodeTill = "-"

  Case "101"
  ReasonRemarkFromReasonCodeTill = "-"

  Case "102"
  ReasonRemarkFromReasonCodeTill = "-"

  Case "103"
  ReasonRemarkFromReasonCodeTill = "Es wurde versucht, eine Mitteilung an eine Nummer zu schicken, die nicht oder nicht mehr existiert. Bitte berprfen Sie, ob Sie die Nummer richtig eingegeben haben."

  Case "104"
  ReasonRemarkFromReasonCodeTill = "-"

  Case "105"
  ReasonRemarkFromReasonCodeTill = "-"

  Case "106"
  ReasonRemarkFromReasonCodeTill = "-"

  Case "107"
  ReasonRemarkFromReasonCodeTill = "Es wurde versucht, eine Mitteilung an ein Mobiltelefon zu schicken, das momentan nicht eingeschaltet ist oder keinen Empfang hat."

  Case "108"
  Select Case sDST
    Case "1"
    ReasonRemarkFromReasonCodeTill = "Es wurde versucht, eine Mitteilung zu schicken, die SMS konnte jedoch nicht im Mobiltelefon gespeichert werden." & " " & "Dieser Reasoncode wurde schon hufig beobachtet, wenn der Handyspeicher voll war und kein Platz fr weitere Mitteilungen vorhanden war. Falls der Empfnger eine oder mehrere SMS lscht, kann die Mitteilung wahrscheinlich trotzdem noch ausgeliefert werden."
    
    Case "2"
    ReasonRemarkFromReasonCodeTill = "Die Gltigkeitsdauer der Mitteilung wurde berschritten."
    
  End Select

  Case "109"
  ReasonRemarkFromReasonCodeTill = "-"

  Case "110"
  ReasonRemarkFromReasonCodeTill = "Dieser Reasoncode wurde schon hufig im Zusammenhang mit Nokia 91xx Mobiltelefonen und der Verwendung von alphanumerischen Absendern beobacht, es sind jedoch auch andere Fehlerursachen denkbar."

  Case "111"
  ReasonRemarkFromReasonCodeTill = "-"

  Case "112"
  ReasonRemarkFromReasonCodeTill = "-"

  Case "113"
  ReasonRemarkFromReasonCodeTill = "-"

  Case "114"
  ReasonRemarkFromReasonCodeTill = "-"

  Case "115"
  ReasonRemarkFromReasonCodeTill = "-"

  Case "116"
  ReasonRemarkFromReasonCodeTill = "-"

  Case "117"
  ReasonRemarkFromReasonCodeTill = "-"

  Case "118"
  ReasonRemarkFromReasonCodeTill = "Es wurde versucht, eine Mitteilung zu schicken, es ist jedoch ein nicht nher spezifizierbarer Fehler im Netzwerk aufgetreten. Dieser Fehler wurde schon bei nicht erreichbaren oder berlasteten Netzwerken und kriegerischen Ereignissen beobachtet."

  Case "119"
  ReasonRemarkFromReasonCodeTill = "Es wurde versucht, eine Mitteilung zu schicken, ist es jedoch ein Fehler im Netzwerk (Public Land Mobile Network) aufgetreten."

  Case "120"
  ReasonRemarkFromReasonCodeTill = "Es wurde versucht, eine Mitteilung zu schicken, es ist jedoch ein schwerer Fehler im Netzwerk (Home Location Register) aufgetreten." & " " & "Dieser Reasoncode wurde schon hufig beobachtet, wenn versucht wurde, eine SMS in ein Netzwerk zu schicken, das nicht erreichbar ist. In der Regel wird dann hufig nach Ablauf der Gltigkeitsdauer ein bertragungsfehler (Code 108) angezeigt."

  Case "121"
  ReasonRemarkFromReasonCodeTill = "Es wurde versucht, eine Mitteilung zu schicken, es ist jedoch ein Fehler im Netzwerk (Visiting Location Register) aufgetreten." & " " & "Dieser Reasoncode wurde schon im Zusammenhang mit Roamingproblemen beobachtet, z.B. wenn sich der Empfnger im Ausland befand und sein Mobiltelefon in einem Netzwerk eingebucht war, dass keinen SMS Roamingvertrag mit seinem Heimnetzwerk abgeschlossen hatte."

  Case "122"
  ReasonRemarkFromReasonCodeTill = "-"

  Case "123"
  ReasonRemarkFromReasonCodeTill = "Es wurde versucht, eine Mitteilung zu schicken, es ist jedoch ein Fehler im Netzwerk (Controlling MSC) aufgetreten." & " " & "Dieser Reasoncode wurde schon im Zusammenhang mit Roamingproblemen beobachtet, z.B. wenn sich der Empfnger im Ausland befand und sein Mobiltelefon in einem Netzwerk eingebucht war, dass keinen SMS Roamingvertrag mit seinem Heimnetzwerk abgeschlossen hatte."

  Case "124"
  ReasonRemarkFromReasonCodeTill = "-"

  Case "125"
  ReasonRemarkFromReasonCodeTill = "-"

  Case "126"
  ReasonRemarkFromReasonCodeTill = "-"

  Case "127"
  ReasonRemarkFromReasonCodeTill = "-"

  Case "200"
  ReasonRemarkFromReasonCodeTill = "-"

  Case "201"
  ReasonRemarkFromReasonCodeTill = "-"

  Case "202"
  ReasonRemarkFromReasonCodeTill = "-"

  Case "203"
  ReasonRemarkFromReasonCodeTill = "-"

  Case "204"
  ReasonRemarkFromReasonCodeTill = "-"

  Case "205"
  ReasonRemarkFromReasonCodeTill = "-"

  Case "206"
  ReasonRemarkFromReasonCodeTill = "-"

  Case "207"
  ReasonRemarkFromReasonCodeTill = "-"

  Case "208"
  ReasonRemarkFromReasonCodeTill = "-"

  Case Else
  ReasonRemarkFromReasonCodeTill = "Unbekannter Fehlercode"

End Select
End Function




Function ReasonRemarkFromReasonCode(sReasonCode As String, sDST As String) As String
Select Case sReasonCode

  Case ""
  ReasonRemarkFromReasonCode = ""

  Case "000"
  ReasonRemarkFromReasonCode = LoadLanguageSpecificString(gnLanguage, 351)

  Case "001"
  ReasonRemarkFromReasonCode = "-"

  Case "002"
  ReasonRemarkFromReasonCode = "-"

  Case "003"
  ReasonRemarkFromReasonCode = "-"

  Case "004"
  ReasonRemarkFromReasonCode = "-"

  Case "005"
  ReasonRemarkFromReasonCode = "-"

  Case "006"
  ReasonRemarkFromReasonCode = "-"

  Case "007"
  ReasonRemarkFromReasonCode = "-"

  Case "008"
  ReasonRemarkFromReasonCode = "-"

  Case "009"
  ReasonRemarkFromReasonCode = "-"

  Case "010"
  ReasonRemarkFromReasonCode = "-"

  Case "100"
  ReasonRemarkFromReasonCode = "-"

  Case "101"
  ReasonRemarkFromReasonCode = "-"

  Case "102"
  ReasonRemarkFromReasonCode = "-"

  Case "103"
  ReasonRemarkFromReasonCode = LoadLanguageSpecificString(gnLanguage, 352)

  Case "104"
  ReasonRemarkFromReasonCode = "-"

  Case "105"
  ReasonRemarkFromReasonCode = "-"

  Case "106"
  ReasonRemarkFromReasonCode = "-"

  Case "107"
  ReasonRemarkFromReasonCode = LoadLanguageSpecificString(gnLanguage, 353)

  Case "108"
  Select Case sDST
    Case "1"
    ReasonRemarkFromReasonCode = LoadLanguageSpecificString(gnLanguage, 354) & " " & LoadLanguageSpecificString(gnLanguage, 355)
    
    Case "2"
    ReasonRemarkFromReasonCode = LoadLanguageSpecificString(gnLanguage, 356)
    
  End Select

  Case "109"
  ReasonRemarkFromReasonCode = "-"

  Case "110"
  ReasonRemarkFromReasonCode = LoadLanguageSpecificString(gnLanguage, 358)

  Case "111"
  ReasonRemarkFromReasonCode = "-"

  Case "112"
  ReasonRemarkFromReasonCode = "-"

  Case "113"
  ReasonRemarkFromReasonCode = "-"

  Case "114"
  ReasonRemarkFromReasonCode = "-"

  Case "115"
  ReasonRemarkFromReasonCode = "-"

  Case "116"
  ReasonRemarkFromReasonCode = "-"

  Case "117"
  ReasonRemarkFromReasonCode = "-"

  Case "118"
  ReasonRemarkFromReasonCode = LoadLanguageSpecificString(gnLanguage, 359)

  Case "119"
  ReasonRemarkFromReasonCode = LoadLanguageSpecificString(gnLanguage, 360)

  Case "120"
  ReasonRemarkFromReasonCode = LoadLanguageSpecificString(gnLanguage, 361) & " " & LoadLanguageSpecificString(gnLanguage, 362)

  Case "121"
  ReasonRemarkFromReasonCode = LoadLanguageSpecificString(gnLanguage, 363) & " " & LoadLanguageSpecificString(gnLanguage, 364)

  Case "122"
  ReasonRemarkFromReasonCode = "-"

  Case "123"
  ReasonRemarkFromReasonCode = "-"

  Case "124"
  ReasonRemarkFromReasonCode = "-"

  Case "125"
  ReasonRemarkFromReasonCode = "-"

  Case "126"
  ReasonRemarkFromReasonCode = "-"

  Case "127"
  ReasonRemarkFromReasonCode = "-"

  Case "200"
  ReasonRemarkFromReasonCode = "-"

  Case "201"
  ReasonRemarkFromReasonCode = "-"

  Case "202"
  ReasonRemarkFromReasonCode = "-"

  Case "203"
  ReasonRemarkFromReasonCode = "-"

  Case "204"
  ReasonRemarkFromReasonCode = "-"

  Case "205"
  ReasonRemarkFromReasonCode = "-"

  Case "206"
  ReasonRemarkFromReasonCode = "-"

  Case "207"
  ReasonRemarkFromReasonCode = "-"

  Case "208"
  ReasonRemarkFromReasonCode = "-"

  Case Else
  ReasonRemarkFromReasonCode = LoadLanguageSpecificString(gnLanguage, 310)

End Select
End Function





Function ReasonFromReasonCode(sReasonCode As String) As String
Select Case sReasonCode

  Case ""
  ReasonFromReasonCode = ""

  Case "000"
  ReasonFromReasonCode = LoadLanguageSpecificString(gnLanguage, 261)

  Case "001"
  ReasonFromReasonCode = LoadLanguageSpecificString(gnLanguage, 262)

  Case "002"
  ReasonFromReasonCode = LoadLanguageSpecificString(gnLanguage, 263)

  Case "003"
  ReasonFromReasonCode = LoadLanguageSpecificString(gnLanguage, 264)

  Case "004"
  ReasonFromReasonCode = LoadLanguageSpecificString(gnLanguage, 265)

  Case "005"
  ReasonFromReasonCode = LoadLanguageSpecificString(gnLanguage, 266)

  Case "006"
  ReasonFromReasonCode = LoadLanguageSpecificString(gnLanguage, 267)

  Case "007"
  ReasonFromReasonCode = LoadLanguageSpecificString(gnLanguage, 268)

  Case "008"
  ReasonFromReasonCode = LoadLanguageSpecificString(gnLanguage, 269)

  Case "009"
  ReasonFromReasonCode = LoadLanguageSpecificString(gnLanguage, 270)

  Case "010"
  ReasonFromReasonCode = LoadLanguageSpecificString(gnLanguage, 271)

  Case "100"
  ReasonFromReasonCode = LoadLanguageSpecificString(gnLanguage, 272)

  Case "101"
  ReasonFromReasonCode = LoadLanguageSpecificString(gnLanguage, 273)

  Case "102"
  ReasonFromReasonCode = LoadLanguageSpecificString(gnLanguage, 274)

  Case "103"
  ReasonFromReasonCode = LoadLanguageSpecificString(gnLanguage, 275)

  Case "104"
  ReasonFromReasonCode = LoadLanguageSpecificString(gnLanguage, 276)

  Case "105"
  ReasonFromReasonCode = LoadLanguageSpecificString(gnLanguage, 277)

  Case "106"
  ReasonFromReasonCode = LoadLanguageSpecificString(gnLanguage, 278)

  Case "107"
  ReasonFromReasonCode = LoadLanguageSpecificString(gnLanguage, 279)

  Case "108"
  ReasonFromReasonCode = LoadLanguageSpecificString(gnLanguage, 281)

  Case "109"
  ReasonFromReasonCode = LoadLanguageSpecificString(gnLanguage, 282)

  Case "110"
  ReasonFromReasonCode = LoadLanguageSpecificString(gnLanguage, 283)

  Case "111"
  ReasonFromReasonCode = LoadLanguageSpecificString(gnLanguage, 284)

  Case "112"
  ReasonFromReasonCode = LoadLanguageSpecificString(gnLanguage, 285)

  Case "113"
  ReasonFromReasonCode = LoadLanguageSpecificString(gnLanguage, 286)

  Case "114"
  ReasonFromReasonCode = LoadLanguageSpecificString(gnLanguage, 287)

  Case "115"
  ReasonFromReasonCode = LoadLanguageSpecificString(gnLanguage, 288)

  Case "116"
  ReasonFromReasonCode = LoadLanguageSpecificString(gnLanguage, 289)

  Case "117"
  ReasonFromReasonCode = LoadLanguageSpecificString(gnLanguage, 290)

  Case "118"
  ReasonFromReasonCode = LoadLanguageSpecificString(gnLanguage, 291)

  Case "119"
  ReasonFromReasonCode = LoadLanguageSpecificString(gnLanguage, 292)

  Case "120"
  ReasonFromReasonCode = LoadLanguageSpecificString(gnLanguage, 293)

  Case "121"
  ReasonFromReasonCode = LoadLanguageSpecificString(gnLanguage, 294)

  Case "122"
  ReasonFromReasonCode = LoadLanguageSpecificString(gnLanguage, 295)

  Case "123"
  ReasonFromReasonCode = LoadLanguageSpecificString(gnLanguage, 296)

  Case "124"
  ReasonFromReasonCode = LoadLanguageSpecificString(gnLanguage, 297)

  Case "125"
  ReasonFromReasonCode = LoadLanguageSpecificString(gnLanguage, 298)

  Case "126"
  ReasonFromReasonCode = LoadLanguageSpecificString(gnLanguage, 299)

  Case "127"
  ReasonFromReasonCode = LoadLanguageSpecificString(gnLanguage, 300)

  Case "200"
  ReasonFromReasonCode = LoadLanguageSpecificString(gnLanguage, 301)

  Case "201"
  ReasonFromReasonCode = LoadLanguageSpecificString(gnLanguage, 302)

  Case "202"
  ReasonFromReasonCode = LoadLanguageSpecificString(gnLanguage, 303)

  Case "203"
  ReasonFromReasonCode = LoadLanguageSpecificString(gnLanguage, 304)

  Case "204"
  ReasonFromReasonCode = LoadLanguageSpecificString(gnLanguage, 305)

  Case "205"
  ReasonFromReasonCode = LoadLanguageSpecificString(gnLanguage, 306)

  Case "206"
  ReasonFromReasonCode = LoadLanguageSpecificString(gnLanguage, 307)

  Case "207"
  ReasonFromReasonCode = LoadLanguageSpecificString(gnLanguage, 308)

  Case "208"
  ReasonFromReasonCode = LoadLanguageSpecificString(gnLanguage, 309)

  Case Else
  ReasonFromReasonCode = LoadLanguageSpecificString(gnLanguage, 310)

End Select
End Function





Function ConvertToASPSMSTimeFormat(sInput As String) As String
Dim dTemp As Date
Dim sDay As String
Dim sMonth As String
Dim sYear As String
Dim sHour As String
Dim sMinute As String
Dim sSecond As String

'The dateformat has to be: ddmmyyyyhhmmss
If IsDate(sInput) Then
  dTemp = CVDate(sInput)
  sDay = Right("00" & DatePart("d", dTemp), 2)
  sMonth = Right("00" & DatePart("m", dTemp), 2)
  sYear = DatePart("yyyy", dTemp)
  sHour = Right("00" & DatePart("h", dTemp), 2)
  sMinute = Right("00" & DatePart("n", dTemp), 2)
  sSecond = Right("00" & DatePart("s", dTemp), 2)
  ConvertToASPSMSTimeFormat = sDay & sMonth & sYear & sHour & sMinute & sSecond
Else
  ConvertToASPSMSTimeFormat = ""
End If
End Function


Function SendLogSQLStatement(nLanguage As Integer, sSQLWhere As String) As String
Dim sSQL As String
Dim sWhere As String
Dim sTemp As String
sSQL = "SELECT lID as ID, "
sSQL = sSQL & "sName as [" & LoadLanguageSpecificString(gnLanguage, 600) & "], "
sSQL = sSQL & "sRecipient as [" & LoadLanguageSpecificString(gnLanguage, 601) & "], "
sSQL = sSQL & "sTransactionReferenceNumber as [" & LoadLanguageSpecificString(gnLanguage, 602) & "], "
sSQL = sSQL & "sMessage as [" & LoadLanguageSpecificString(gnLanguage, 603) & "], "
sSQL = sSQL & "dDeferredDeliveryTime as [" & LoadLanguageSpecificString(gnLanguage, 604) & "], "
sSQL = sSQL & "dSubmissionDate as [" & LoadLanguageSpecificString(gnLanguage, 605) & "], "
sSQL = sSQL & "dNotificationDate as [" & LoadLanguageSpecificString(gnLanguage, 606) & "], "
sSQL = sSQL & "sReasoncode as [" & LoadLanguageSpecificString(gnLanguage, 607) & "], "
sSQL = sSQL & "dNotificationDateBuffered as [" & LoadLanguageSpecificString(gnLanguage, 608) & "], "
sSQL = sSQL & "sReasonCodeBuffered as [" & LoadLanguageSpecificString(gnLanguage, 609) & "], "
sSQL = sSQL & "sReasonTextBuffered as [" & LoadLanguageSpecificString(gnLanguage, 610) & "], "
sSQL = sSQL & "sDeliveryStatus as [" & LoadLanguageSpecificString(gnLanguage, 611) & "], "
sSQL = sSQL & "sDeliveryStatusText as [" & LoadLanguageSpecificString(gnLanguage, 612) & "], "
sSQL = sSQL & "sReasonText as [" & LoadLanguageSpecificString(gnLanguage, 613) & "], "
sSQL = sSQL & "lJobID "
sSQL = sSQL & "FROM SendJournal "
       
sSQL = "SELECT lID as ID, "

If gtDBLogFieldsSettings.bSendLog(2) = True Then
  sSQL = sSQL & "lJobID as [" & LoadLanguageSpecificString(nLanguage, 615) & "], "
End If

If gtDBLogFieldsSettings.bSendLog(3) = True Then
  sSQL = sSQL & "sName as [" & LoadLanguageSpecificString(gnLanguage, 600) & "], "
End If

If gtDBLogFieldsSettings.bSendLog(4) = True Then
  sSQL = sSQL & "sRecipient as [" & LoadLanguageSpecificString(gnLanguage, 601) & "], "
End If

If gtDBLogFieldsSettings.bSendLog(5) = True Then
  sSQL = sSQL & "sTransactionReferenceNumber as [" & LoadLanguageSpecificString(gnLanguage, 602) & "], "
End If

If gtDBLogFieldsSettings.bSendLog(6) = True Then
  sSQL = sSQL & "sMessage as [" & LoadLanguageSpecificString(gnLanguage, 603) & "], "
End If

If gtDBLogFieldsSettings.bSendLog(7) = True Then
  sSQL = sSQL & "dDeferredDeliveryTime as [" & LoadLanguageSpecificString(gnLanguage, 604) & "], "
End If

If gtDBLogFieldsSettings.bSendLog(8) = True Then
  sSQL = sSQL & "dSubmissionDate as [" & LoadLanguageSpecificString(gnLanguage, 605) & "], "
End If

If gtDBLogFieldsSettings.bSendLog(9) = True Then
  sSQL = sSQL & "dNotificationDate as [" & LoadLanguageSpecificString(gnLanguage, 606) & "], "
End If

If gtDBLogFieldsSettings.bSendLog(10) = True Then
  sSQL = sSQL & "sReasoncode as [" & LoadLanguageSpecificString(gnLanguage, 607) & "], "
End If

If gtDBLogFieldsSettings.bSendLog(11) = True Then
  sSQL = sSQL & "dNotificationDateBuffered as [" & LoadLanguageSpecificString(gnLanguage, 608) & "], "
End If

If gtDBLogFieldsSettings.bSendLog(12) = True Then
  sSQL = sSQL & "sReasonCodeBuffered as [" & LoadLanguageSpecificString(gnLanguage, 609) & "], "
End If

If gtDBLogFieldsSettings.bSendLog(13) = True Then
  sSQL = sSQL & "sReasonTextBuffered as [" & LoadLanguageSpecificString(gnLanguage, 610) & "], "
End If

If gtDBLogFieldsSettings.bSendLog(14) = True Then
  sSQL = sSQL & "sDeliveryStatus as [" & LoadLanguageSpecificString(gnLanguage, 611) & "], "
End If

If gtDBLogFieldsSettings.bSendLog(15) = True Then
  sSQL = sSQL & "sDeliveryStatusText as [" & LoadLanguageSpecificString(gnLanguage, 612) & "], "
End If

If gtDBLogFieldsSettings.bSendLog(16) = True Then
  sSQL = sSQL & "sReasonText as [" & LoadLanguageSpecificString(gnLanguage, 613) & "], "
End If

sSQL = Left(sSQL, Len(sSQL) - 2)

sSQL = sSQL & " FROM SendJournal "
       
If gtSendLogFilterSettings.bRecipientNameFilterUsed Then
  sWhere = sWhere & "(sName = '" & gtSendLogFilterSettings.sRecipientName & "') and "
End If

If gtSendLogFilterSettings.bRecipientFilterUsed Then
  sWhere = sWhere & "(sRecipient = '" & gtSendLogFilterSettings.sRecipient & "') and "
End If

If gtSendLogFilterSettings.bDeliveryStatusFilterUsed Then
  If gtSendLogFilterSettings.nDeliveryStatus = gcQuestionMarks Then
    sWhere = sWhere & "(sDeliveryStatus = '???') and "
  Else
    sWhere = sWhere & "(sDeliveryStatus = '" & gtSendLogFilterSettings.nDeliveryStatus & "') and "
  End If
End If

If gtSendLogFilterSettings.bReasonCodeFilterUsed Then
  If gtSendLogFilterSettings.nReasonCode = gcQuestionMarks Then
    sWhere = sWhere & "(sReasoncode = '???' or sReasonCodeBuffered = '???') and "
  Else
    If gtSendLogFilterSettings.nReasonCode = 0 Then 'Special case 0, Unknown subscriber
      sWhere = sWhere & "((sReasoncode = '000' or sReasonCodeBuffered = '000') and "
      sWhere = sWhere & "(sDeliveryStatus = '1' or sDeliveryStatus = '2')) and "
    Else
      sWhere = sWhere & "(sReasoncode = '" & gtSendLogFilterSettings.nReasonCode & "' or sReasonCodeBuffered = '" & gtSendLogFilterSettings.nReasonCode & "') and "
    End If
  End If
End If

If gtSendLogFilterSettings.bJobIDFilterUsed Then
  sWhere = sWhere & "(lJobID = " & gtSendLogFilterSettings.lJobId & ") and "
End If

If sWhere <> "" Then 'Cut off last 'and'
  sWhere = "WHERE " & Left(sWhere, Len(sWhere) - 4)
End If

sSQLWhere = sWhere
SendLogSQLStatement = sSQL & sWhere & " ORDER BY lID"

End Function
Sub SetListIndexWithItemData(cboInput As ComboBox, nItemdata As Integer)
Dim nListIndex As Integer
Dim bFound As Boolean

nListIndex = 0
Do While Not bFound And (nListIndex + 1) <= cboInput.ListCount
  If cboInput.ItemData(nListIndex) = nItemdata Then
    cboInput.ListIndex = nListIndex
    bFound = True
  End If
  nListIndex = nListIndex + 1
Loop

End Sub

Sub ShowCredits(bEnableMessagebox As Boolean)
Dim SMS As Booster
Dim rCredits As Double
Dim sMessage As String

Set SMS = New Booster

SMS.Hosts = App.Path & "\smshosts.txt"
SMS.UserKey = frmSMSBlaster.txtUserkey.Text
SMS.Password = frmSMSBlaster.txtPassword.Text

Screen.MousePointer = vbHourglass

rCredits = SMS.Credits

frmSMSBlaster.Caption = gsApplicationName & " - " & LoadLanguageSpecificString(gnLanguage, 186) & " " & Trim(Str$(rCredits)) & " " & LoadLanguageSpecificString(gnLanguage, 488)

Screen.MousePointer = vbDefault

Set SMS = Nothing

If bEnableMessagebox Then
  sMessage = LoadLanguageSpecificString(gnLanguage, 450) & " " & Trim(Str$(rCredits)) & " " & LoadLanguageSpecificString(gnLanguage, 451)
  MsgBox sMessage, vbInformation, gsApplicationName
End If

End Sub
Function SelectedSMSType(nLanguage As Integer) As String
Dim nIndex As Integer
Dim sTemp As String

Select Case True
  
  Case frmSMSBlaster.optSMSType(0).Value = True 'Text SMS
  nIndex = 0
  
  Case frmSMSBlaster.optSMSType(1).Value = True 'Operatorlogo
  nIndex = 1
  
  Case frmSMSBlaster.optSMSType(2).Value = True 'Grouplogo
  nIndex = 2
  
  Case frmSMSBlaster.optSMSType(3).Value = True 'Ringtone
  nIndex = 3
  
  Case frmSMSBlaster.optSMSType(4).Value = True 'Picturemessage
  nIndex = 4
  
  Case frmSMSBlaster.optSMSType(5).Value = True 'VCard
  nIndex = 5
  
  Case frmSMSBlaster.optSMSType(6).Value = True 'Unicode
  nIndex = 6
  
  Case frmSMSBlaster.optSMSType(7).Value = True 'WAP Push SMS
  nIndex = 7
  
  Case frmSMSBlaster.optSMSType(8).Value = True 'Binary Data
  nIndex = 8
      
  Case frmSMSBlaster.optSMSType(9).Value = True
  nIndex = 9
    
  Case frmSMSBlaster.optSMSType(10).Value = True
  nIndex = 10
    
  Case frmSMSBlaster.optSMSType(11).Value = True
  nIndex = 11
    
    
End Select

Select Case nIndex
  Case 0
  SelectedSMSType = LoadLanguageSpecificString(nLanguage, 161)
  
  Case 1
  SelectedSMSType = LoadLanguageSpecificString(nLanguage, 162)
  
  Case 2
  SelectedSMSType = LoadLanguageSpecificString(nLanguage, 163)
  
  Case 3
  SelectedSMSType = LoadLanguageSpecificString(nLanguage, 164)
  
  Case 4
  SelectedSMSType = LoadLanguageSpecificString(nLanguage, 165)
  
  Case 5
  SelectedSMSType = LoadLanguageSpecificString(nLanguage, 166)
  
  Case 6
  SelectedSMSType = LoadLanguageSpecificString(nLanguage, 480)
  
  Case 7
  SelectedSMSType = LoadLanguageSpecificString(nLanguage, 478)
  
  Case 8
  SelectedSMSType = LoadLanguageSpecificString(nLanguage, 167)
  
  Case 9
  VersionSpecificAction 25, nLanguage, , sTemp
  SelectedSMSType = sTemp
  
  Case 10
  VersionSpecificAction 26, nLanguage, , sTemp
  SelectedSMSType = sTemp
  
  Case 11
  VersionSpecificAction 27, nLanguage, , sTemp
  SelectedSMSType = sTemp
    
  Case Else
  SelectedSMSType = ""
End Select
  
End Function
Function TimeZoneFromListBoxSetting(nListIndex As Integer) As Integer
TimeZoneFromListBoxSetting = nListIndex - 12
End Function

Sub UpdateJobList(nLanguage As Integer)
On Error GoTo ErrorTrap
Dim lRecipient As Long
Dim k As Long
Dim dWork As Date
Dim sRecipient As String
Dim lRecipientMultiplier As Long
Dim lCountMessages As Long
Dim lCountRecipients As Long
Dim sJobInfo As String

frmSMSBlaster.lstCurrentJob.Clear
Screen.MousePointer = vbHourglass

lCountRecipients = frmSMSBlaster.grdRecipients.Rows - 1
lRecipientMultiplier = 1

For lRecipient = 1 To lCountRecipients

  sRecipient = frmSMSBlaster.grdRecipients.TextMatrix(lRecipient, 0) & " " & frmSMSBlaster.grdRecipients.TextMatrix(lRecipient, 1)   'Number of the Recipient
  If gtDeferredDeliveryTimeSettings.bUseDeferredDeliveryTime = False Then
    'Do nothing
    frmSMSBlaster.lstCurrentJob.AddItem SelectedSMSType(nLanguage) & " " & LoadLanguageSpecificString(nLanguage, 172) & " " & sRecipient
  Else
    If gtDeferredDeliveryTimeSettings.bSingleSMS = True Then
      frmSMSBlaster.lstCurrentJob.AddItem gtDeferredDeliveryTimeSettings.sDeliveryDate & " / " & SelectedSMSType(nLanguage) & " " & LoadLanguageSpecificString(nLanguage, 172) & " " & sRecipient
    Else
      If IsDate(gtDeferredDeliveryTimeSettings.sStartingDate) Then
        dWork = CVDate(gtDeferredDeliveryTimeSettings.sStartingDate)
        lRecipientMultiplier = Val(gtDeferredDeliveryTimeSettings.sNumberOfMessages)
        For k = 1 To Val(gtDeferredDeliveryTimeSettings.sNumberOfMessages)
          frmSMSBlaster.lstCurrentJob.AddItem dWork & " / " & SelectedSMSType(nLanguage) & Str$(k) & " " & LoadLanguageSpecificString(nLanguage, 172) & " " & sRecipient
          Select Case gtDeferredDeliveryTimeSettings.nWaitingPeriod

            Case 0 'Seconds
            dWork = DateAdd("s", gtDeferredDeliveryTimeSettings.sWaitingTime, dWork)

            Case 1 'Minutes
            dWork = DateAdd("n", gtDeferredDeliveryTimeSettings.sWaitingTime, dWork)

            Case 2 'Hours
            dWork = DateAdd("h", gtDeferredDeliveryTimeSettings.sWaitingTime, dWork)

            Case 3 'Days
            dWork = DateAdd("d", gtDeferredDeliveryTimeSettings.sWaitingTime, dWork)

            Case 4 'Weeks
            dWork = DateAdd("ww", gtDeferredDeliveryTimeSettings.sWaitingTime, dWork)

            Case 5 'Months
            dWork = DateAdd("m", gtDeferredDeliveryTimeSettings.sWaitingTime, dWork)
            
            Case Else
            'Unexecpted, do nothing, probably an application bug
            
          End Select
        Next
      End If
    End If
  End If
Next
Screen.MousePointer = vbDefault

frmSMSBlaster.lblCurrentRecipients = LoadLanguageSpecificString(nLanguage, 120) & " " & Trim(Str$(frmSMSBlaster.grdRecipients.Rows - 1))

lCountMessages = lCountRecipients * lRecipientMultiplier

If lRecipientMultiplier > 1 Then
  sJobInfo = LoadLanguageSpecificString(nLanguage, 117) & " " & Trim(Str$(lCountRecipients)) & " " & _
             LoadLanguageSpecificString(nLanguage, 91) & " / " & Trim(Str$(lCountMessages)) & " " & LoadLanguageSpecificString(nLanguage, 452)
Else
  sJobInfo = LoadLanguageSpecificString(nLanguage, 117) & " " & Trim(Str$(lCountRecipients)) & " " & _
             LoadLanguageSpecificString(nLanguage, 91)
End If

frmSMSBlaster.fraCurrentJob = sJobInfo

gtJobInfo.lMessages = 0
gtJobInfo.lRecipients = 0
gtJobInfo.tDeferredDeliveryTimeSettings = gtDeferredDeliveryTimeSettings

VersionSpecificAction 57, nLanguage

UpdateJobInfoScreen nLanguage
Exit Sub
ErrorTrap:
Screen.MousePointer = vbDefault
End Sub
Function ValidityPeriodWithSpecificSettings(tValidityPeriodSettings As ValidityPeriodSettings, tDeferredDeliveryTimeSettings As DeferredDeliveryTimeSettings, bPeriodic As Boolean) As ValidityPeriod
Dim tValidityPeriod As ValidityPeriod

If bPeriodic = False Then
  tValidityPeriod.bUserDefinedSettingsOnlyForSpecificSMSTypes = tValidityPeriodSettings.bSingleSMSUseUserDefinedSettingsOnlyForSpecificSMSTypes
    
  Select Case tValidityPeriodSettings.nSingleSMSValidityPeriodMode
    Case ValidityPeriodMode.UseSpecificSettingsAsLifeTime
    tValidityPeriod.lLifeTime = tValidityPeriodSettings.lSingleSMSSpecificSettingLifeTime
    tValidityPeriod.nLifeTimeUnit = tValidityPeriodSettings.nSingleSMSSpecificSettingLifeTimeUnit
    tValidityPeriod = TrimValidityPeriodToCorrectValues(tValidityPeriod)
        
    Case ValidityPeriodMode.UseSingleshotAsLifeTime
    tValidityPeriod.lLifeTime = 0
    tValidityPeriod.nLifeTimeUnit = 0
    tValidityPeriod = TrimValidityPeriodToCorrectValues(tValidityPeriod)
   
    Case ValidityPeriodMode.UseWaitingTimeAsLifeTime
    'Do nothing, not possible
    
  End Select
Else
  tValidityPeriod.bUserDefinedSettingsOnlyForSpecificSMSTypes = tValidityPeriodSettings.bPeriodicSMSUseUserDefinedSettingsOnlyForSpecificSMSTypes
  
  Select Case tValidityPeriodSettings.nPeriodicSMSValidityPeriodMode
    Case ValidityPeriodMode.UseSpecificSettingsAsLifeTime
    tValidityPeriod.lLifeTime = tValidityPeriodSettings.lPeriodicSMSSpecificSettingLifeTime
    tValidityPeriod.nLifeTimeUnit = tValidityPeriodSettings.nPeriodicSMSSpecificSettingLifeTimeUnit
    tValidityPeriod = TrimValidityPeriodToCorrectValues(tValidityPeriod)
        
    Case ValidityPeriodMode.UseSingleshotAsLifeTime
    tValidityPeriod.lLifeTime = 0
    tValidityPeriod.nLifeTimeUnit = 0
    tValidityPeriod = TrimValidityPeriodToCorrectValues(tValidityPeriod)
   
    Case ValidityPeriodMode.UseWaitingTimeAsLifeTime
    Select Case tDeferredDeliveryTimeSettings.nWaitingPeriod
      Case 0 'Seconds
      tValidityPeriod.lLifeTime = Val(tDeferredDeliveryTimeSettings.sWaitingTime) / 60
      tValidityPeriod.nLifeTimeUnit = 0
      tValidityPeriod = TrimValidityPeriodToCorrectValues(tValidityPeriod)
            
      Case 1 'Minutes
      tValidityPeriod.nLifeTimeUnit = 0
      tValidityPeriod.lLifeTime = Val(tDeferredDeliveryTimeSettings.sWaitingTime)
      tValidityPeriod = TrimValidityPeriodToCorrectValues(tValidityPeriod)
            
      Case 2 'Hours
      tValidityPeriod.nLifeTimeUnit = 1
      tValidityPeriod.lLifeTime = Val(tDeferredDeliveryTimeSettings.sWaitingTime)
      tValidityPeriod = TrimValidityPeriodToCorrectValues(tValidityPeriod)
      
      Case 3 'Days
      tValidityPeriod.nLifeTimeUnit = 1
      tValidityPeriod.lLifeTime = 24
      tValidityPeriod = TrimValidityPeriodToCorrectValues(tValidityPeriod)
      
      Case 4 'Weeks
      tValidityPeriod.nLifeTimeUnit = 1
      tValidityPeriod.lLifeTime = 24
      tValidityPeriod = TrimValidityPeriodToCorrectValues(tValidityPeriod)
      
      Case 5 'Months
      tValidityPeriod.nLifeTimeUnit = 1
      tValidityPeriod.lLifeTime = 24
      tValidityPeriod = TrimValidityPeriodToCorrectValues(tValidityPeriod)
      
    End Select
    
  End Select
End If

ValidityPeriodWithSpecificSettings = tValidityPeriod
End Function
